      SUBROUTINE MN_FQU(IUSEE,NMODE,IDELIM,IERR)
C
C     GETS THE FUNCTION NUMBERS TO BE USED IN CALCULATING THE VALUE
C     OF A FUNCTION
C
C     NMODE = -1  MEANS ONLY ALLOW IN USE FUNCTIONS, BUT
C                 DON'T INCREMENT THE FUNCTION NUMBER BEING PLOTTED
C     NMODE = 0   MEANS ONLY ALLOW IN USE FUNCTIONS AND INCREMENT THE
C                 FUNCTION NUMBER BEING PLOTTED
C     NMODE = 1   MEANS ALLOW ALL ADDED FUNCTIONS TO BE SPECIFIED
C                 BUT DON'T INCREMENT THE FUNCTION NUMBER BEING PLOTTED
C
#include "mnpar.inc"
#include "mnfun.inc"
#include "mncmd.inc"
#include "mnlun.inc"
C
      INTEGER IUSEE(*)
      LOGICAL QPFUN
C
      IERR = 0
      QPFUN = .FALSE.
      CALL VZERO_i(IUSEE(1),NFUN_MN)
C
      IF(.NOT.QRFILE .AND. IDELIM.LT.0) THEN
          IF(NMODE.LE.0) THEN
              WRITE(LUNTTO,'('' The following functions are being''
     1         ,'' used:'')')
          ELSE
              WRITE(LUNTTO,'('' The following functions have been''
     1         ,'' defined:'')')
          ENDIF
          DO 2300 NF=1,NFUN_MN
              IF(NMODE.LE.0 .AND. IUSEF(NF).EQ.0) GOTO 2300
              WRITE(LUNTTO,'(1X,I4,2X,A)') NF,TUSEF(NF)
 2300     CONTINUE
      ENDIF
C
 2400 CONTINUE
      NF = INTTYQ(.TRUE.,IDELIM)
      IF(IDELIM.GT.0) THEN
C
C         IS IT A REAL NUMBER?
C
          CALL RESTYQ
          RVAL = RELTYQ(.TRUE.,IDELIM)
          IF(IDELIM.LE.0) THEN
              CALL RESTYQ
              GOTO 2500
          ENDIF
C
C         IS IT AN AMPERSAND?
C
          IF(IDELIM.EQ.ICHAR('&')) THEN
              GOTO 2500
          ENDIF
C
          CALL RESTYQ
C
C         See if it is a register etc.
C
          NF = IVLTYQ(.TRUE.,IDELIM)
      ENDIF
C
      CALL MN_NCK(NF,IDELIM,NERR)
      IF(NERR.NE.0) THEN
          IF(QRFILE) THEN
              IERR = 1
              GOTO 9000
          ELSE
              IF(NERR.EQ.2) THEN
                  IERR = 1
                  GOTO 9000
              ENDIF
              GOTO 2400
          ENDIF
      ENDIF
      IF(NF.GT.0 .AND. NF.LE.NFUN_MN) THEN
          QPFUN = .TRUE.
          IUSEE(NF) = 1
      ELSEIF(NF.EQ.0) THEN
          QPFUN = .TRUE.
          CALL VFILL(IUSEE,NFUN_MN,1)
          GOTO 2500
      ENDIF
C
      IF(IDELIM.EQ.0) GOTO 2400
C
 2500 CONTINUE
      IF(.NOT.QPFUN) THEN
          WRITE(LUNTTO,'('' You did not give any valid''
     1     ,'' function numbers'')')
          IERR = 1
          GOTO 9000
      ENDIF
C
C     Check if any of the functions is a smooth histogram.
C     If so calculate the smoothing parameters.
C
      DO 3000 NF=1,NFUN_MN
          IF(IUSEE(NF).EQ.1 .AND. INUMF(NF).EQ.LFHSMO) THEN
              CALL M_FHSMO(NF,IERR)
              IF(IERR.NE.0) GOTO 9000
          ENDIF
 3000 CONTINUE
C
 9000 CONTINUE
      END
