      SUBROUTINE M_CAPT(NMODE,MDEV,IDELIM,IERR)
C
C-----------------------------------------------------------------------
C
C     Finds out the device name to be captured.
C     NMODE = 0 means all devices
C             1 means screen devices
C             2 means hardcopy devices
C     NDEV  = 0 Ask for device name
C             Any other value means device number is given
C
C     Called by MN_CMD
C
C-----------------------------------------------------------------------
C
#include "mngrn.inc"
#include "mnlun.inc"
*
#if ( defined(X11) )
*ICB      COMMON /HIKERN/ LOHOST
*ICB      LOGICAL LOHOST
      COMMON /HIKERC/ CHHOST
      CHARACTER*80 CHHOST
#endif

C
      INTEGER NLIST
      PARAMETER (NLIST = 2)
      INTEGER ILIST(NLIST)
      LOGICAL QQUAL
      CHARACTER*10 TCOMM
*ICB      CHARACTER*10 CAPQUL(4)
      CHARACTER*20 TNAM
      CHARACTER*40 THOST
      CHARACTER*80 TEXT
      LOGICAL QCHOST
*ICB      DATA CAPQUL/'REPLACE','ADD','HARDCOPY',' '/
C
      QQUAL = IDELIM.EQ.ICHAR('/')
      IF(MDEV.NE.0) THEN
          NDEV = MDEV
          KWTYPE = 0
          NGRNUM = -1
          GOTO 3000
      ENDIF
#if ( defined(X11) )
C
C     Get all the devices out of HIGZ_WINDOWS.DAT
C
      CALL M_XFILE(1)
      QCHOST = .FALSE.
#endif

C
 1000 CONTINUE
      IF(NMODE.EQ.0) THEN
          CALL WAITYQ('Give device name, number or ?: ')
      ELSEIF(NMODE.EQ.1) THEN
          CALL WAITYQ('Give screen device name, number or ?: ')
      ELSEIF(NMODE.EQ.2) THEN
          CALL WAITYQ('Give hardcopy device name, number or ?: ')
      ENDIF
C
C     See if device number is given
C
      JCMD = INTTYQ(.TRUE.,IDELIM)
      IF(JCMD.EQ.0 .AND. IDELIM.EQ.ICHAR('?')) THEN
          CALL TVHLP(NMODE)
          GOTO 1000
#if ( defined(X11) )
C
C     Take whatever has been set and see what happens.
C     This should work on VMS for SET DISPLAY... ETC.
C
      ELSEIF((NMODE.EQ.0 .OR. NMODE.EQ.1) .AND.
     + JCMD.EQ.0 .AND. IDELIM.EQ.-1 .AND. NCHSCN().EQ.0) THEN
          QCHOST = .FALSE.
          NDEV = 10 + MDISP0
          KWTYPE = 0
          NGRNUM = -1
          GOTO 3000
#endif

      ELSEIF(JCMD.EQ.0 .AND. IDELIM.EQ.-1 .AND. NCHSCN().EQ.0) THEN
          IERR = 2
          GOTO 9000
#if ( defined(X11) )
      ELSEIF(JCMD.GT.0 .AND. JCMD.LE.10 .AND.
     +       (IDELIM.LE.0 .OR. IDELIM.EQ.ICHAR('.'))) THEN
          NDEV = JCMD + MDISP0
          IF(IDELIM.LE.0) THEN
              TEXT = TPDEV(NDEV)
              LENT = LENOCC(TEXT)
              IF(TEXT.EQ.'DISPLAY') THEN
                  WRITE(TXTMES,'('' There is no host in line'',I3
     +             ,'' of higz_windows.dat'')') JCMD
                  CALL MN_MES(LUNTTO,'M',TXTMES)
                  TXTMES = ' $DISPLAY will be used'
                  CALL MN_MES(LUNTTO,'M',TXTMES)
                  TNAM = 'DISPLAY'
                  TEXT = ' '
                  CALL M_TLOGI(TNAM,LENT,ISTAT,TEXT)
                  IF(ISTAT.EQ.0) THEN
                      TXTERR = 'Environment variable DISPLAY is not set'
                      CALL MN_ERR('M_CAPT',TXTERR)
                      IERR = 6
                      GOTO 9000
                  ENDIF
                  qchost = .true.
              ELSE
                  IF(INDEX(TEXT(1:LENT),':').EQ.0) THEN
                      THOST = TEXT(1:LENT) // ':0.0'
                      QCHOST = .TRUE.
                  ELSE
                      THOST = TEXT(1:LENT)
                      QCHOST = .FALSE.
                  ENDIF
                  LENT = LENOCC(THOST)
                  CALL M_SLOGI('DISPLAY',THOST(1:LENT))
                  QCHOST = .TRUE.
              ENDIF
          ELSEIF(IDELIM.EQ.ICHAR('.')) THEN
              NCHAR = ISLTYQ(.TRUE.,IDELIM,TEXT)
              IF(NCHAR.GT.0) THEN
                  IF(INDEX(TEXT(1:NCHAR),':').EQ.0) THEN
                      TPDEV(NDEV) = TEXT(1:NCHAR) // ':0.0'
                      QCHOST = .TRUE.
                  ELSE
                      TPDEV(NDEV) = TEXT(1:NCHAR)
                      QCHOST = .FALSE.
                  ENDIF
                  LEND = LENOCC(TPDEV(NDEV))
                  TPNAM(NDEV) = 'X Windows Display on ' //
     +             TPDEV(NDEV)(1:LEND)
                  CALL M_XFILE(2)
                  THOST = TPDEV(NDEV)(1:LEND)
                  CALL M_SLOGI('DISPLAY',THOST(1:LEND))
              ELSE
                  TNAM  = 'DISPLAY'
                  THOST = ' '
                  CALL M_TLOGI(TNAM,LENT,ISTAT,THOST)
                  IF(ISTAT.EQ.0) THEN
                      TXTERR = 'Environment variable DISPLAY is not set'
                      CALL MN_ERR('M_CAPT',TXTERR)
                      IERR = 6
                      GOTO 9000
                  ENDIF
                  TPDEV(NDEV) = THOST(1:LENT)
                  TPNAM(NDEV) = 'X Windows Display on ' // THOST(1:LENT)
                  text = tpdev(ndev)
                  tpdev(ndev) = 'DISPLAY'
                  CALL M_XFILE(2)
                  tpdev(ndev) = text
                  QCHOST = .FALSE.
              ENDIF
          ENDIF
#endif
#if ( !defined(X11) )
      ELSEIF(JCMD.EQ.0 .OR. IDELIM.GT.0) THEN
#endif
#if ( defined(X11) )
      ELSEIF(JCMD.EQ.0) THEN
#endif

          CALL RESTYQ
          IF(NMODE.EQ.0) THEN
              JCMD   = ICMTYQ(.TRUE.,IDELIM,TPDEV)
          ELSEIF(NMODE.EQ.1) THEN
              JCMD   = ICMTYQ(.TRUE.,IDELIM,TPSOF)
          ELSEIF(NMODE.EQ.2) THEN
              JCMD   = ICMTYQ(.TRUE.,IDELIM,TPHRD)
          ENDIF
          IF(JCMD.EQ.0) THEN
              NMATCH = ICMLST(NLIST,ILIST)
              IF(NMATCH.GT.0 .AND. TPDEV(ILIST(1)).EQ.'Unknown') THEN
                  CALL MN_ERR('M_CAPT'
     +                ,'You must give the device number')
                  GOTO 9000
#if ( defined(X11) )
              ELSEIF(NMATCH.GT.0 .AND.TPDEV(ILIST(1)).EQ.'DISPLAY') THEN
                  JCMD  = 10 + MDISP0
                  TNAM  = 'DISPLAY'
                  THOST = ' '
                  CALL M_TLOGI(TNAM,LENT,ISTAT,THOST)
                  IF(ISTAT.EQ.0) THEN
                      TXTERR = 'Environment variable DISPLAY is not set'
                      CALL MN_ERR('M_CAPT',TXTERR)
                      IERR = 6
                      GOTO 9000
                  ENDIF
                  TPDEV(JCMD) = THOST(1:LENT)
                  TPNAM(JCMD) = 'X Windows Display on ' // THOST(1:LENT)
                  QCHOST = .FALSE.
                  GOTO 2000
#endif

              ELSE
                  IF(NMODE.EQ.1 .OR. NMODE.EQ.2) THEN
                      CALL MN_DCK(IDELIM,JCMD,MPDEV,TPDEV,IERR)
                  ELSEIF(NMODE.EQ.2) THEN
                      CALL MN_DCK(IDELIM,JCMD,MPHRD,TPHRD,IERR)
                  ENDIF
                  IF(IERR.EQ.2) THEN
                      CALL ICMSTR(TCOMM)
                      CALL MN_ERR('M_CAPT','Unknown device: ' // TCOMM)
                  ENDIF
                  GOTO 9000
              ENDIF
          ENDIF
 2000     CONTINUE
          IF(NMODE.EQ.0 .OR. NMODE.EQ.1) THEN
              NDEV = JCMD
#if ( defined(X11) )
              IF(NDEV.GT.MDISP0 .AND. NDEV.LE.MDISP0+10) THEN
                  THOST = TPDEV(JCMD)
                  LENT = LENOCC(THOST)
                  CALL M_SLOGI('DISPLAY',THOST(1:LENT))
                  QCHOST = .TRUE.
              ENDIF
#endif

          ELSE
              NDEV = JCMD + MPSOF
          ENDIF
          NGRNUM = -1
          KWTYPE = 0
      ELSE
          IF(NMODE.EQ.0 .OR. NMODE.EQ.1) THEN
              NDEV = MPSOF
          ELSE
              NDEV = MPHRD + MPSOF
          ENDIF
          NGRNUM = -1
          KWTYPE = JCMD
      ENDIF
C
#if ( defined(X11) )
      IF(NDEV.GT.MDISP0 .AND. NDEV.LE.MDISP0+10) THEN
          TNAM  = 'DISPLAY'
          THOST = ' '
          CALL M_TLOGI(TNAM,LENT,ISTAT,THOST)
          LENT = MAX0(1,LENT)
          TXTMES = ' DISPLAY is set to ' // THOST(1:LENT)
          CALL MN_MES(LUNTTO,'ME',TXTMES)
*ICB          lohost = .true.
          chhost = ' '
          if(qchost) then
              ind = index(thost(1:lent),':')
              if(ind.gt.0) then
                  if(ind.eq.1) then
                      chhost = ' '
                  else
                      chhost = thost(1:ind-1)
                  endif
              else
                  chhost = thost(1:lent)
              endif
          endif
      ENDIF
#endif

C
 3000 CONTINUE
      IF(NDEV.GT.0 .AND. NDEV.LE.MPDEV) THEN
          CALL TVCAP(NDEV,KWTYPE,NGRNUM,IERR)
      ELSE
          CALL MN_ERR('M_CAPT','Error in device name or number')
      ENDIF
C
 9000 CONTINUE
      END
