      subroutine m_spw2(comand,txt1,len1,txt2,len2,ierr)
C
C     SUBROUTINE CONTAINING VAX CODE USED FOR SPAWNING SUBPROCESSES
C     OR EDITING A FILE FROM WITHIN MN_FIT.
C
      implicit none
*
#include "mnpar.inc"
#include "mncmd.inc"
#include "mnflg.inc"
#include "mnlun.inc"
C
      character comand*(*),txt1*(*),txt2*(*)
      integer len1,len2,ierr
C
#if ( defined(VMS) )
      INCLUDE '($JPIDEF)/LIST'
      INCLUDE '($LIBDEF)/LIST'
      integer lmes,istat,npid
      integer lib$spawn,lib$sys_getmsg,lib$getjpi,lib$attach
c      EXTERNAL TPU$_EXITING
C
#endif

C
      CHARACTER*255 TXT3
      integer nchar,lensh,lene,len3
      integer lnblnk
      integer  systemf
      external systemf
C
      LOGICAL QSTART
      DATA QSTART/.TRUE./
C
C     Do any initialization that is necessary
C
      IF(QSTART) THEN
          QSTART = .FALSE.
      ENDIF
C
C     SPAWN A SINGLE LINE COMMAND
C     OR A SUBPROCESS
C
      IF(COMAND.EQ.'SPAWN' .OR. COMAND.EQ.'SHELL') THEN
          nchar = len1
C
#if ( defined(VMS) )
          IF(NCHAR.GT.0) THEN
              ISTAT = LIB$SPAWN('$ ' // TXT1(1:NCHAR))
              call lib$sys_getmsg(istat,lmes,txt3)
              txtmes = ' Spawn status: ' // txt3(:lmes)
              call mn_mes(LUNTTO,'ME',txtmes)
          ELSE
              WRITE(LUNTTO,*) 'Type ''return'' to return to Mn_Fit'
              ISTAT = LIB$SPAWN('$ RETURN:==LOGOFF'
     +         ,'SYS$COMMAND','SYS$COMMAND')
          ENDIF
          IF(.NOT.ISTAT) THEN
              txterr = 'Error trying to spawn'
              call m_emsg('MN_SPW',txterr)
              CALL LIB$SIGNAL(%VAL(ISTAT))
              call lib$sys_getmsg(istat,lmes,txt3)
              txterr = 'Spawn status: ' // txt3(:lmes)
              call mn_err('MN_SPW',txterr)
              ierr = 1
          ENDIF
#endif
#if ( defined(UNIX) )
          LENSH = LNBLNK(TSHELL)
          IF(NCHAR.GT.0) THEN
              txt3 = TSHELL(:LENSH) // ' -c ''' // TXT1(:NCHAR) // ''''
              ierr =  systemf(txt3(:lensh + nchar + 6))
          ELSE
              WRITE(LUNTTO,*) 'Type ''exit'' to return to Mn_Fit'
              ierr = systemf(TSHELL(:LENSH))
          ENDIF
          if(ierr.ne.0) then
              call mn_err('M_SPW2','Error return from shell command')
          endif
#endif
#if ( !defined(VMS) ) && ( !defined(UNIX) )
          CALL M_EMSG('MN_SPW'
     +     ,'Command not implemented on this computer')
          CALL MN_ERR('MN_SPW','Use ctrl-z to go to shell' //
     +     ' and fg to return')
          ierr = 1
#endif

C
C     EDIT A FILE
C
      ELSEIF(COMAND.EQ.'EDIT') THEN
          nchar = len2
#if ( defined(VMS) )
          txt3 = txt1
          LENE = len1
          CALL CLTOU(TXT3(1:LENe))
C
C         Use callable TPU for tpu or edfor
C
c          IF(TXT2(1:8).EQ.'EDIT/TPU' .OR. TXT2(1:3).EQ.'EDF') THEN
c              LEN2 = NCHAR
c              IND = INDEX(TXT2(1:NCHAR),';')
c              IF(IND.GT.0) LEN2 = IND - 1
c              TXT3  = TXT2(1:LEN2)
c              ISTAT = TPU$EDIT(TXT3(1:NCHAR),TXT2)
C
C             Check for exit or quit
C
c              IF(IAND(ISTAT,'FFFFFFF'X).EQ.%LOC(TPU$_EXITING)) THEN
C                 exit
c              ELSE
C                 quit
c              ENDIF
c          ELSE
              TXT3 = txt1(:len1) // ' ' // txt2(:nchar)
              ISTAT = LIB$SPAWN('$' // TXT3)
              IF(.NOT.ISTAT) THEN
                  CALL LIB$SIGNAL(%VAL(ISTAT))
                  ierr = 1
              ENDIF
c          ENDIF
#endif
#if ( defined(UNIX) )
          LENE = len1
          TXT3 = TXT1(1:LENE) // ' ' // TXT2(1:NCHAR)
          LEN3 = LENE + 1 + NCHAR
          ierr = systemf(TXT3(1:LEN3))
          if(ierr.ne.0) then
              call mn_err('M_SPW2','Error return from edit command')
          endif
#endif
#if ( !defined(VMS) ) && ( !defined(UNIX) )
          CALL M_EMSG('MN_SPW'
     +     ,'Command not implemented on this computer')
          CALL MN_ERR('MN_SPW','Use ctrl-z to go to shell' //
     +     ' and fg to return to MN_FIT')
#endif

C
C     ATTACH TO ANOTHER SUBPROCESS
C
      ELSE IF(COMAND.EQ.'ATTACH') THEN
#if ( defined(VMS) )
          ISTAT = LIB$GETJPI(JPI$_PID,,Txt1(:len1),NPID)
          IF(.NOT.ISTAT) THEN
              CALL LIB$SIGNAL(%VAL(ISTAT))
              GOTO 9000
          ENDIF
C
          ISTAT = LIB$ATTACH(NPID)
          IF(.NOT.ISTAT) THEN
              CALL LIB$SIGNAL(%VAL(ISTAT))
          ENDIF
#endif
#if ( !defined(VMS) )
          CALL M_EMSG('MN_SPW'
     +     ,'Command not implemented on this computer')
          CALL MN_ERR('MN_SPW','Use ctrl-z to go to shell' //
     +     ' and fg to return to MN_FIT')
#endif

      ENDIF
C
9000  CONTINUE
      END
