      SUBROUTINE MN_LKC(NFITTP,WEE,WFUN,WNORM,WDEEL2,WDEEH2,WFERR2
     1 ,WDCHI,WDLIK,NFN0,NMESS)
C
C     SUBROUTINE TO CALCULATE THE CHI**2 AND LIKELIHOOD FOR
C     A DATA POINT AND THE ASSOCIATED FUNCTION
C
      IMPLICIT NONE
C
#include "mnlun.inc"
C
      INTEGER NFITTP,NFN0,NMESS
      DOUBLE PRECISION WEE,WFUN,WNORM,WFUNI,WDEEL2,WDEEH2,WFERR2
      DOUBLE PRECISION WDF,WDEE2,WDCHI,WDLIK,WMC,WNORMI
      DOUBLE PRECISION DLGAMA
C
      WDCHI = 0.0D0
      WDLIK = 0.0D0
      WDF = WEE - WFUN
      IF(WEE.GT.WFUN) THEN
          WDEE2 = WDEEL2
      ELSE
          WDEE2 = WDEEH2
      ENDIF
C
C     CHI**2 FIT
C
      IF(NFITTP.EQ.0) THEN
          WDCHI = 0.0D0
          WDF = DSIGN(DMIN1(DABS(WDF),1.0D+16),WDF)
          WDF = DSIGN(DMAX1(DABS(WDF),1.0D-16),WDF)
          IF(WDEE2.GT.0.0D0) WDCHI = WDF*WDF / (WDEE2 + WFERR2)
C
C     LIKELIHOOD FIT
C
      ELSEIF(NFITTP.EQ.1 .OR. NFITTP.EQ.8) THEN
          WDLIK = 0.0D0
          IF(WFUN.LE.0.0D0) THEN
              NFN0  = NFN0 + 1
              NMESS = NMESS + 1
              IF(NMESS.LE.5) THEN
                  WRITE(TXTMES
     1             ,'('' Fit function 0 or negative!!''
     2             ,'' Maybe you need to exclude an''
     3             ,'' unphysical region'')')
                  CALL MN_MES(LUNTTO,'ME',TXTMES)
              ENDIF
              WFUNI = 0.0D0
          ELSE
              WFUNI = 1.0D0 / WFUN
          ENDIF
          WDLIK = 0.0D0
          IF(WEE.GT.0.0D0 .AND. WFUN.GT.0.0D0) WDLIK =
     1     WEE * DLOG(WEE*WFUNI)
          WDLIK = WDLIK - WDF
          IF(WDLIK.LT.0.0D0) WDLIK = 1000.0D0 * DABS(WDLIK)
          WDLIK = 2.0D0*WDLIK
C
          WDCHI = 0.0D0
          WDF = DSIGN(DMIN1(DABS(WDF),1.0D+16),WDF)
          WDF = DSIGN(DMAX1(DABS(WDF),1.0D-16),WDF)
          IF(WFUN.GT.0.0D0) WDCHI = WDF*WDF * WFUNI
C
C     LIKELIHOOD FIT INCLUDING FUNCTION STATISTICS
C
      ELSEIF(NFITTP.EQ.2 .OR. NFITTP.EQ.9) THEN
          WDLIK = 0.0D0
          IF(WFUN.LE.0.0D0) THEN
              NFN0  = NFN0 + 1
              NMESS = NMESS + 1
              IF(NMESS.LE.5) THEN
                  WRITE(TXTMES
     1             ,'('' Fit function 0 or negative!!''
     2             ,'' Maybe you need to exclude an''
     3             ,'' unphysical region'')')
                  CALL MN_MES(LUNTTO,'ME',TXTMES)
              ENDIF
              WFUNI = 0.0D0
          ELSE
              WFUNI = 1.0D0 / WFUN
          ENDIF
          WMC = WFUN / WNORM
          IF(WNORM.GT.0.0D0) THEN
              WNORMI = 1.0D0 / WNORM
              WDLIK = DLGAMA(WEE+WMC+1.0D0) -
     +         DLGAMA(WEE+1.0D0) - DLGAMA(WMC+1.0D0) +
     +         (WMC+1.0D0)*DLOG(WNORMI) -
     +         (WEE+WMC+1.0D0)*DLOG(WNORMI+1.0D0)
          ELSE
              WDLIK = -1.0D+16
          ENDIF
          WDLIK = -2.0D0*WDLIK
          IF(WFUN.LE.0.0D0) WDLIK = 1000.0D0 * WDLIK
C
          WDCHI = 0.0D0
          WDF = DSIGN(DMIN1(DABS(WDF),1.0D+16),WDF)
          WDF = DSIGN(DMAX1(DABS(WDF),1.0D-16),WDF)
          IF(WFUN.GT.0.0D0) WDCHI = WDF*WDF * WFUNI
      ENDIF
C
      RETURN
      END
