      SUBROUTINE M_LOOP(IDELIM,IERR)
C
C------------------------------------------------------------------------------
C     Start a DO loop
C
C     Called from MN_CMD
C------------------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "mnpar.inc"
#include "mnfit.inc"
#include "mncmd.inc"
#include "mntyq.inc"
#include "mnlun.inc"
#include "mndbg.inc"
C
      INTEGER IDELIM,IERR
C
      INTEGER JCMD,IEQUL,K,NMIN,NMAX,NSTEP,NFDEP,NFDEPO,NTDEPO
      LOGICAL QSAVE
      CHARACTER TCOMM*10,TJUNK(2)*10
      CHARACTER TXT1*80
C
      INTEGER  ICMTYQ,ICHTYP,LNBLNK
      REAL     VALTYQ
      EXTERNAL ICMTYQ,ICHTYP,VALTYQ
C
      DATA TJUNK/'DO',' '/
C
      ierr = 0
*
      IF(.NOT.QRFILE) THEN
          CALL MN_ERR('MN_CMD','Command only valid' //
     1     ' inside a file or an internally defined command')
          ierr = 1
          GOTO 9000
      ENDIF
      IF(NFORDP(NTDEP).GE.MFORDP) THEN
          WRITE(TXT1,'(''You cannot nest more than'',I3
     1     ,'' DO loops'')') MTDEP
          CALL MN_ERR('MN_CMD',TXT1)
          ierr = 2
          GOTO 9000
      ENDIF
      IF(IDELIM.LT.0) THEN
          CALL MN_ERR('MN_CMD','Variable name is missing')
          ierr = 3
          GOTO 9000
      ENDIF
      CALL WAITYQ('Give variable, start, maximum and step size: ')
      JCMD = ICMTYQ(.TRUE.,IDELIM,TJUNK)
      TCOMM = ' '
      CALL ICMSTR(TCOMM)
      IF(LNBLNK(TCOMM).GT.1) CALL MN_ERR('MN_CMD'
     1 ,'Variable names can only have 1 letter. ' //
     2 'It will be trimmed')
C
C     LOOK FOR THE EQUALS SIGN
C
      IF(IDELIM.NE.ICHAR('=')) THEN
          IEQUL = INDEX(STRING,'=')
          IF(IEQUL.LT.0) THEN
              CALL MN_ERR('MN_CMD','Equals sign is missing')
              ierr = 4
              GOTO 9000
          ENDIF
 2300     CONTINUE
          K = ICHTYP(.TRUE.)
          IF(K.EQ.ICHAR(' ')) GOTO 2300
      ENDIF
C
      IF(IDELIM.LT.0) THEN
          CALL MN_ERR('MN_CMD','Starting value for loop missing')
          ierr = 5
          GOTO 9000
      ENDIF
      NMIN = NINT(VALTYQ(.TRUE.,IDELIM))
      IF(IDELIM.LT.0) THEN
          CALL MN_ERR('MN_CMD','Maximum value for loop missing')
          ierr = 6
          GOTO 9000
      ENDIF
      NMAX = NINT(VALTYQ(.TRUE.,IDELIM))
C
      IF(IDELIM.EQ.0) THEN
          NSTEP = NINT(VALTYQ(.TRUE.,IDELIM))
          IF(NSTEP.EQ.0) THEN
              CALL MN_ERR('MN_CMD','Step value of 0 is illegal' //
     1         '. It will be set to 1')
              NSTEP = 1
          ENDIF
      ELSE
          NSTEP = 1
      ENDIF
C
      NFORDP(NTDEP) = NFORDP(NTDEP) + 1
      NFDEP = NFORDP(NTDEP)
      IF(LUNCMD.GT.0) THEN
          IFORBG(NFDEP,NTDEP) = IUNREC(NTDEP)
      ELSE
          IFORBG(NFDEP,NTDEP) = IP1CMD(NTDEP)
      ENDIF
C
C     STORE THE VARIABLE AS UPPER CASE
C
      CALL M_LUPC(TCOMM(1:1),TCOMM(1:1))
      TFORNM(NFDEP,NTDEP) = TCOMM(1:1)
      IFORVL(NFDEP,NTDEP) = NMIN
      IFORMX(NFDEP,NTDEP) = NMAX
      IFORST(NFDEP,NTDEP) = NSTEP
*
      if(qdebug .and. ndebug.ge.110) then
        write(luntto,'('' DO loop set up NFDEP/NTDEP'',2I4
     +   ,'', Line'',I6)')
     +   nfdep,ntdep,iforbg(nfdep,ntdep)
      endif
C
C     NOW CHECK WHETHER THE LOOP SHOULD BE EXECUTED
C
      IF((NSTEP.GT.0 .AND. NMIN.GT.NMAX) .OR.
     1   (NSTEP.LT.0 .AND. NMIN.LT.NMAX)) THEN
          QDSKIP = .TRUE.
          NFDEPO = NFDEP
          NTDEPO = NTDEP
          IF(NHFIT.GT.0) THEN
              CALL WAITYQ('MINUIT_SKIP> ')
          ELSE
              CALL WAITYQ('MN_CMD_SKIP> ')
          ENDIF
 2310     CONTINUE
          QSAVE = QECHO
CICB          QECHO = .FALSE.
          JCMD = ICMTYQ(.TRUE.,IDELIM,TJUNK)
          COMND2 = ' '
          IF(JCMD.GT.0) CALL ICMSTR(COMND2)
CICB          IF(JCMD.GT.0) COMND2 = TJUNK(JCMD)
          IF(COMND2.EQ.'DO') THEN
              NFORDP(NTDEP) = NFORDP(NTDEP) + 1
          ENDIF
          CALL ZERTYQ('.FALSE.')
          QECHO = QSAVE
          IF(NTDEP.GE.NTDEPO .AND. NFORDP(NTDEP).GE.NFDEPO) THEN
              GOTO 2310
          ELSE
C
C             CLEAR OUT THE COMMAND AND SET UP FOR NORMAL COMMAND
C             PROCESSING AGAIN
C
              QDSKIP = .FALSE.
              GOTO 9000
          ENDIF
      ENDIF
C
 9000 CONTINUE
      END
