      SUBROUTINE MN_CSI
C
C     INITIALIZE COMIS STORAGE SPACE
C     AND SET UP THE UNITS NEEDED FOR COMIS
C     ALSO DEFINE ADDRESSES OF ROUTINES AND COMMON BLOCKS THAT CAN BE USED
C
      implicit none
C
C     Mn_Fit routines
C
      EXTERNAL         XMNCLC, XMNCNT, XMNFRG, XMNHIS, XMNRD3, XMNRES
     + ,XMNC2D, XMNDFUN
      external smctrl,smqhan,smrmed,smrmen,smsort
      DOUBLE PRECISION XMNCLC, XMNCNT, XMNFRG, XMNHIS, XMNRD3, XMNRES
     + ,XMNC2D, XMNDFUN
      EXTERNAL         RMNCLC, RMNCNT, RMNFRG, RMNHIS, RMNRD3, RMNRES
     + ,RMNC2D, RMNDFUN
      REAL             RMNCLC, RMNCNT, RMNFRG, RMNHIS, RMNRD3, RMNRES
     + ,RMNC2D, RMNDFUN
C
C     CERN routines in PAW
C
*
      EXTERNAL HBOOK1,HBOOK2,HBOOKN,HFILL,HF1,HPRINT,HDELET,HRESET
      EXTERNAL HFITGA,HFITPO,HFITEX,HPROJ1,HPROJ2,HFN,HGFIT
      EXTERNAL HROPEN,PAOPEN,PACLOS,PAREAD,PAWRIT,HCDIR,HGIVEN
      EXTERNAL HBFUN1,HBFUN2,HRNDM1,HRNDM2,HBARX,HBARY
      EXTERNAL HPAK,HPAKE,HUNPAK,HGIVE,HGN,HGNF,HGNPAR,HF2,HFF1,HFF2
      EXTERNAL HRIN,HROUT,HI,HIE,HIX,HIJ,HIF,HIDALL,HNOENT,HX,HXY
      EXTERNAL HTITLE,HCOPY,HSTATI,HBPROF,HOPERA,HIDOPT,HDERIV
      EXTERNAL HMAXIM,HMINIM,HMAX,HMIN,HSUM,HNORMA,HREND,HRENDC
      EXTERNAL HEXIST,HRGET,HRPUT,HSCR,HFIND,HCX,HCXY,HLABEL
      EXTERNAL HBPROX,HBPROY,HBANDX,HBANDY,HBSLIX,HBSLIY
      EXTERNAL HBOOKB,HBSTAT,HDIFF,HUNPKE,HREBIN,HERROR,HPROF2
      EXTERNAL HOUTPU,HERMES,HISTDO,HFUNC,HXI,HIJXY,HXYIJ
      EXTERNAL HSPLI1,HSPLI2,HMDIR,HLDIR,HRDIR,HLOCAT,HFITH,HFITV,HFINAM
      EXTERNAL HBNT,HBNAME,HBNAMC,HFNT,HFNTB,HGNT,HGNTF,HGNTV,HBSET
      EXTERNAL HGNTB,HNBENT,HVXIST,HLPOS,HFC1
**    EXTERNAL HMCINI,HMCMLL
      EXTERNAL FZIN,FZOUT,FZFILE,FZENDI,FZENDO,MZLOGL
      EXTERNAL HPLOT,HPLSYM,HPLERR,HPLEGO,HPLNT,HPLSUR,HPLSOF,HPLFRA
      EXTERNAL HPLABL,HPLSET,HPLGIV,HPLOC,HPLTOC,HPLNEW,HPLOPT
      EXTERNAL MNEMAT,MNERRS,MNSTAT
      EXTERNAL KUGETV,KUDPAR,KUVECT,KILEXP,KUTIME,KUEXEL,KUPROS
      EXTERNAL KUNWG,KUCMD,KUGUID,KUNDPV,KUPAR,KUPVAL,KUACT
      EXTERNAL IPL,IPM,IFA,IGTEXT,IGBOX,IGAXIS,IGPIE,IGRAPH,IGHIST
      EXTERNAL IGARC,IGLBL,IGRNG,IGMETA,IGSA,IGSET,IRQLC,IRQST,ISCR
      EXTERNAL ISELNT,ISFAIS,ISFASI,ISLN,ISMK,ISVP,ISWN,ITX,ICLRWK
      EXTERNAL IGPAVE,IGTERM
      EXTERNAL RZCDIR,RZLDIR,RZFILE,RZEND,RZIN,RZOUT,RZVIN,RZVOUT
      EXTERNAL RZOPEN,RZIODO,RZCLOS,RZQUOT
      EXTERNAL VZERO,UCOPY,RNDM,RANNOR,LENOCC,CLTOU,CUTOL,TIMED
      EXTERNAL SBIT0,SBIT1,SBYT,JBIT,JBYT,UCTOH,UHTOC,PROB,FREQ
      EXTERNAL DENLAN,DSTLAN,DIFLAN,XM1LAN,XM2LAN,RANLAN
      EXTERNAL ERF,ERFC
C
C     Extra CERN routines for Mn_Fit
C
      EXTERNAL BINSIZ
      REAL GAMMA
      DOUBLE PRECISION DERF,DERFC,DFREQ,DGAMMA
      EXTERNAL DERF,DERFC,DFREQ,GAMMA,DGAMMA
      external ranmar,rmarin,rmarut,rmmar,rmmaq
      external ranecu,ranecq
      external ranlux,rluxgo,rluxat,rluxin,rluxut
      external rnorml,rnormx
      external funlxp,funlux
      external radapt,rgs56p
C
#include "mnpar.inc"
#include "mnusr.inc"
#include "mntpl.inc"
#include "mncwn.inc"
#include "mnprs.inc"
#include "mndbg.inc"
C
      real cs
      common/comis/cs(10000)
C     Common block from FUNRAN
      real fint
      common /funint/ fint
C
      real p(1)
      double precision z(1)
      integer lunpm,lunfil,lunlog,lunmap,lunedt
C
      LUNPM  = 81
      LUNFIL = 82
      LUNLOG = 83
      LUNMAP = 84
      LUNEDT = 85
      CALL CLEO_LOKLUN(LUNPM,'MN_CSI')
      CALL CLEO_LOKLUN(LUNFIL,'MN_CSI')
      CALL CLEO_LOKLUN(LUNLOG,'MN_CSI')
      CALL CLEO_LOKLUN(LUNMAP,'MN_CSI')
      CALL CLEO_LOKLUN(LUNEDT,'MN_CSI')
      CALL CSSETL(LUNPM,LUNFIL,LUNLOG,LUNMAP,LUNEDT)
      CALL CSINIT(10000)
C
C     Mn_Fit Common Blocks
C
      CALL CSCOM('MNUSR,PAWIDN,MNTPL1,MNREGI,MNDBG,PAWCR4,PAWCR8#'
     + ,XMINNM,IDNEVT,ID,REGIS(0),QDEBUG,ar4(1),zr8(1),P,P,P)
      CALL CSCOMC('MNTPL2,PAWCCH#'
     + ,TITLE,CCH(1),P,P,P,P,P,P,P,P)
C
C     CERNLIB common blocks
C
      CALL CSCOM('FUNINT#'
     + ,FINT,P,P,P,P,P,P,P,P,P)
C
C     Mn_Fit routines
C
      CALL CSEXT('XMNCLC.D,XMNCNT.D,XMNFRG.D,XMNHIS.D,XMNRD3.D#'
     + ,XMNCLC,XMNCNT,XMNFRG,XMNHIS,XMNRD3
     + ,Z,Z,Z,Z,Z)
      CALL CSEXT('XMNRES.D,XMNC2D.D,XMNDFUN.D#'
     + ,XMNRES,XMNC2D,XMNDFUN
     + ,Z,Z,Z,Z,Z,Z,Z)
      CALL CSEXT('RMNCLC.R,RMNCNT.R,RMNFRG.R,RMNHIS.R,RMNRD3.R#'
     + ,RMNCLC,RMNCNT,RMNFRG,RMNHIS,RMNRD3
     + ,P,P,P,P,P)
      CALL CSEXT('RMNRES.R,RMNC2D.R,RMNDFUN.R#'
     + ,RMNRES,RMNC2D,RMNDFUN
     + ,P,P,P,P,P,P,P)
      call csext('SMCTRL,SMQHAN,SMRMED,SMRMEN,SMSORT#'
     +           ,SMCTRL,SMQHAN,SMRMED,SMRMEN,SMSORT
     +           ,P,P,P,P,P)
C
C     Paw, Zebra, Hbook, Hplot, Cernlib routines
C
      CALL CSEXT('HBOOK1,HBOOK2,HBOOKN,HFILL,HF1,HPRINT,HDELET,HRESET#'
     +,           HBOOK1,HBOOK2,HBOOKN,HFILL,HF1,HPRINT,HDELET,HRESET
     +,           P,P)
      CALL CSEXT('HFITGA,HFITPO,HFITEX,HPROJ1,HPROJ2,HFN,HGNPAR#'
     +,           HFITGA,HFITPO,HFITEX,HPROJ1,HPROJ2,HFN,HGNPAR
     +,           P,P,P)
      CALL CSEXT('HROPEN,PAOPEN,PACLOS,PAREAD,PAWRIT,HCDIR,HGIVEN#'
     +,           HROPEN,PAOPEN,PACLOS,PAREAD,PAWRIT,HCDIR,HGIVEN
     +,           P,P,P)
      CALL CSEXT('HPAK,HPAKE,HUNPAK,HGIVE,HGN,HGNF,HF2,HFF1,HFF2#'
     +,           HPAK,HPAKE,HUNPAK,HGIVE,HGN,HGNF,HF2,HFF1,HFF2
     +,           P)
      CALL CSEXT(
     + 'HMAXIM,HMINIM,HMAX.R,HMIN.R,HSUM.R,HNORMA,HREND,HREND#'
     +, HMAXIM,HMINIM,HMAX,HMIN,HSUM,HNORMA,HREND,HRENDC,P,P)
      CALL CSEXT('HI.R,HIE.R,HIX,HIJ.R,HIF.R,HIDALL,HNOENT,HX.R,HXY.R#'
     +,           HI,HIE,HIX,HIJ,HIF,HIDALL,HNOENT,HX,HXY,P)
      CALL CSEXT('HRIN,HROUT,HCOPY,HBPROF,HOPERA,HIDOPT,HDERIV,HGFIT#'
     +,           HRIN,HROUT,HCOPY,HBPROF,HOPERA,HIDOPT,HDERIV,HGFIT
     +,           P,P)
      CALL CSEXT('HEXIST.L,HRGET,HRPUT,HSCR,HFIND,HCX.R,HCXY.R,HLABEL#'
     +,           HEXIST,HRGET,HRPUT,HSCR,HFIND,HCX,HCXY,HLABEL,P,P)
      CALL CSEXT('HBPROX,HBPROY,HBANDX,HBANDY,HBSLIX,HBSLIY#'
     +,           HBPROX,HBPROY,HBANDX,HBANDY,HBSLIX,HBSLIY,P,P,P,P)
      CALL CSEXT('HBOOKB,HBSTAT,HDIFF,HUNPKE,HREBIN,HERROR,HPROF2#'
     +,           HBOOKB,HBSTAT,HDIFF,HUNPKE,HREBIN,HERROR,HPROF2
     +,           P,P,P)
      CALL CSEXT('HOUTPU,HERMES,HISTDO,HFUNC,HXI,HIJXY,HXYIJ,HFINAM#'
     +,           HOUTPU,HERMES,HISTDO,HFUNC,HXI,HIJXY,HXYIJ,HFINAM,P,P)
      CALL CSEXT('HSTATI.R,HLPOS,HFC1#',HSTATI,HLPOS,HFC1,P,P,P,P,P,P,P)
      CALL CSEXT('HSPLI1,HSPLI2,HMDIR,HLDIR,HRDIR,HLOCAT,HFITH,HFITV#'
     +,           HSPLI1,HSPLI2,HMDIR,HLDIR,HRDIR,HLOCAT,HFITH,HFITV
     +,           P,P)
      CALL CSEXT('HTITLE,HBFUN1,HBFUN2,HRNDM1.R,HRNDM2,HBARX,HBARY#'
     +,           HTITLE,HBFUN1,HBFUN2,HRNDM1,HRNDM2,HBARX,HBARY
     +,           P,P,P)
      CALL CSEXT('HPLOT,HPLSYM,HPLERR,HPLEGO,HPLNT,'//
     +           'HPLSUR,HPLSOF,HPLFRA#'
     +,           HPLOT,HPLSYM,HPLERR,HPLEGO,HPLNT,HPLSUR,HPLSOF,HPLFRA
     +,           P,P)
      CALL CSEXT('HPLABL,HPLSET,HPLGIV,HPLOC,HPLTOC,HPLNEW,HPLOPT#'
     +,           HPLABL,HPLSET,HPLGIV,HPLOC,HPLTOC,HPLNEW,HPLOPT,P,P,P)
      CALL CSEXT('HBNT,HBNAME,HBNAMC,HFNT,HFNTB,HGNT,HGNTF,HGNTV,HBSET#'
     +,           HBNT,HBNAME,HBNAMC,HFNT,HFNTB,HGNT,HGNTF,HGNTV,HBSET
     +,           P)
      CALL CSEXT('HGNTB,HNBENT,HVXIST#',HGNTB,HNBENT,HVXIST
     +,           P,P,P,P,P,P,P)
**    CALL CSEXT('HMCINI,HMCMLL#',HMCINI,HMCMLL,P,P,P,P,P,P,P,P)
      CALL CSEXT('MNEMAT,MNERRS,MNSTAT#',MNEMAT,MNERRS,MNSTAT
     +,           P,P,P,P,P,P,P)
      CALL CSEXT('KUGETV,KUDPAR,KUVECT,KILEXP,KUTIME,KUEXEL,KUPROS#'
     +,           KUGETV,KUDPAR,KUVECT,KILEXP,KUTIME,KUEXEL,KUPROS
     +,           P,P,P)
      CALL CSEXT('KUNWG,KUCMD,KUGUID,KUNDPV,KUPAR,KUPVAL,KUACT#'
     +,           KUNWG,KUCMD,KUGUID,KUNDPV,KUPAR,KUPVAL,KUACT,P,P,P)
      CALL CSEXT('IPL,IPM,IFA,IGTEXT,IGBOX,IGAXIS,IGPIE,IGRAPH,IGHIST#'
     +,           IPL,IPM,IFA,IGTEXT,IGBOX,IGAXIS,IGPIE,IGRAPH,IGHIST
     +,           P)
      CALL CSEXT('IGARC,IGLBL,IGRNG,IGMETA,IGSA,IGSET,IRQLC,IRQST,ISCR#'
     +,           IGARC,IGLBL,IGRNG,IGMETA,IGSA,IGSET,IRQLC,IRQST,ISCR
     +,           P)
      CALL CSEXT('ISELNT,ISFAIS,ISFASI,ISLN,ISMK,ISVP,ISWN,ITX,ICLRWK#'
     +,           ISELNT,ISFAIS,ISFASI,ISLN,ISMK,ISVP,ISWN,ITX,ICLRWK
     +,           P)
      CALL CSEXT('IGPAVE,IGTERM#',IGPAVE,IGTERM,P,P,P,P,P,P,P,P)
      CALL CSEXT('FZIN,FZOUT,FZFILE,FZENDI,FZENDO,MZLOGL#'
     +,           FZIN,FZOUT,FZFILE,FZENDI,FZENDO,MZLOGL
     +,           P,P,P,P)
      CALL CSEXT('RZCDIR,RZLDIR,RZFILE,RZEND,RZIN,RZOUT,RZVIN,RZVOUT#'
     +,           RZCDIR,RZLDIR,RZFILE,RZEND,RZIN,RZOUT,RZVIN,RZVOUT
     +,           P,P)
      CALL CSEXT('RZIODO,RZOPEN,RZCLOS,RZQUOT#'
     +,           RZIODO,RZOPEN,RZCLOS,RZQUOT,P,P,P,P,P,P)
      CALL CSEXT('VZERO,UCOPY,RNDM.R,RANNOR,LENOCC.I,CLTOU,CUTOL#'
     +,           VZERO,UCOPY,RNDM,RANNOR,LENOCC,CLTOU,CUTOL
     +,           P,P,P)
      CALL CSEXT('SBIT0,SBIT1,SBYT,JBIT.I,JBYT.I,UCTOH,UHTOC,TIMED#'
     +,           SBIT0,SBIT1,SBYT,JBIT,JBYT,UCTOH,UHTOC,TIMED
     +,           P,P)
      CALL CSEXT('ERF.R,ERFC.R,FREQ.R,PROB.R,RANLAN.R#'
     +,           ERF,ERFC,FREQ,PROB,RANLAN,P,P,P,P,P)
      CALL CSEXT('DENLAN.R,DSTLAN.R,DIFLAN.R,XM1LAN.R,XM2LAN.R#'
     +,           DENLAN,DSTLAN,DIFLAN,XM1LAN,XM2LAN,P,P,P,P,P)
C
C     Extra CERN routines for Mn_Fit
C
      CALL CSEXT('BINSIZ,DERF.D,DERFC.D,DFREQ.D,GAMMA.R,DGAMMA.D#'
     +           ,BINSIZ,DERF,DERFC,DFREQ,GAMMA,DGAMMA
     + ,P,P,P,P)
      CALL CSEXT('RANMAR,RMARIN,RMARUT,RMMAR,RMMAQ,RANECU,RANECQ#'
     +           ,RANMAR,RMARIN,RMARUT,RMMAR,RMMAQ,RANECU,RANECQ
     + ,P,P,P)
      CALL CSEXT('RANLUX,RLUXGO,RLUXAT,RLUXIN,RLUXUT,RNORML,RNORMX#'
     +           ,RANLUX,RLUXGO,RLUXAT,RLUXIN,RLUXUT,RNORML,RNORMX
     + ,P,P,P)
      CALL CSEXT('FUNLXP,FUNLUX#'
     +           ,FUNLXP,FUNLUX
     + ,P,P,P,P,P,P,P,P)
      CALL CSEXT('RADAPT,RGS56P#'
     +           ,RADAPT,RGS56P
     + ,P,P,P,P,P,P,P,P)
C
      END
