      SUBROUTINE MN_HGT(IDA,IDB,NHD)
C
C     IDA,IDB IS THE HISTOGRAM ID WHICH I WANT POINTERS ON
C     NHD IS THE STORAGE POSITION
C     NDIM IS THE NUMBER OF DIMENSIONS
C     NPTRH IS THE POINTER TO THE HEADER
C     NPTRD IS THE POINTER TO THE DATA
C     EDENT ARE THE NUMBER OF ENTRIES
C     EDLO,EDHI ARE THE LOWER AND UPPER LIMITS ON THE NUMBER OF ENTRIES
C     NBPPT IS THE NUMBER OF BITS PER WORD
C
      implicit none
C
#include "mnpar.inc"
#include "mndat.inc"
#include "mninf.inc"
#include "mnflg.inc"
#include "mnlun.inc"
C
      integer ida,idb,nhd
C
      INTEGER IDBINT(MDIMMX)
      REAL ADLOT(MDIMMX),ADHIT(MDIMMX),AMEANT(MDIMMX),ASIGT(MDIMMX)
      integer nnh,ierr,idda,iddb,jj,ii,ii1,ii2,idh,icycle
      integer ndimt,nwpptt,npntt,nhdatt,nhtimt,nsdatt,nstimt,ntmodt
     + ,nbpptt
      real edentt,edlot,edhit
      logical  hexist
      external hexist
C
C     SEE IF THIS HISTOGRAM EXISTS
C
      NHD = 0
      DO 1000 NNH=1,NDHIS
          IF(IDA.EQ.IDIDA(NNH) .AND. IDB.EQ.IDIDB(NNH) .AND.
     1       IDPTRH(NNH).GT.0 .AND. IDPTRD(NNH).GT.0) THEN
              NHD = NNH
              GOTO 2000
          ENDIF
 1000 CONTINUE
*
*     Histogram does not exist - see if it is in the current HBOOK directory
*
      if(qafetch .and. fil_hb.ne.' ') then
          call m_sdir(0,ierr)
          if(ierr.ne.0) then
              nhd = -1
              goto 9000
          endif
          idh = ida
          icycle = 999999
          if(hexist(idh)) call hdelet(idh)
          call hrin(idh,icycle,0)
*
*         See if the histogram was found
*
          if(hexist(idh)) then
              write(6,'('' Histogram'',I7
     +         ,'' fetched from HBOOK file'')') idh
*
*             Now make the HBOOK histogram into a Mn_Fit histogram
*
              call m_hbmn(ida,ida,idb,4)
*
*             See if this histogram exists now
*
              nhd = 0
              do 1200 nnh=1,ndhis
                  if(ida.eq.idida(nnh) .and. idb.eq.ididb(nnh) .and.
     1             idptrh(nnh).gt.0 .and. idptrd(nnh).gt.0) then
                      nhd = nnh
                      goto 2000
                  endif
 1200         continue
          else
              nhd = -1
              goto 9000
          endif
      else
          nhd = -1
          goto 9000
      endif
C
C     CHECK OUT THE POINTERS
C
 2000 CONTINUE
      NPTRH = IDPTRH(NHD)
      NPTRD = IDPTRD(NHD)
      IF(NINT(RDAT(NPTRH+3)).NE.IDA .OR. NINT(RDAT(NPTRH+4)).NE.IDB)
     1 THEN
          IDDA = NINT(RDAT(NPTRH+3))
          IDDB = NINT(RDAT(NPTRH+4))
          WRITE(TXTERR,'(''Something is screwed up''
     1     ,'' with the pointers for plot'',I7,I4)') IDA,IDB
          CALL M_EMSG('MN_HGT',TXTERR)
          WRITE(TXTERR,'(''NHD ='',I4,''  ID in plot itself'',I7,I4)')
     +     NHD,IDDA,IDDB
          CALL M_EMSG('MN_HGT',TXTERR)
          DO 3000 JJ=1,4
              II1 = (JJ-1)*5
              II2 = JJ*5 - 1
              WRITE(TXTERR
     +         ,'(''Words '',I2,'' ->'',I2,2X,5(1PG12.5))')
     +         II1,II2,(RDAT(NPTRH+II),II=II1,II2)
              CALL M_EMSG('MN_HGT',TXTERR)
3000      CONTINUE
          CALL MN_ERR('MN_HGT',' ')
          NHD = 0
          GOTO 9000
      ENDIF
C
      CALL MN_HDR(RDAT(NPTRH),NDIMT,NWPPTT,NPNTT
     + ,NHDATT,NHTIMT,NSDATT,NSTIMT,NTMODT
     1 ,EDENTT,EDLOT,EDHIT,IDBINT,ADLOT,ADHIT,NBPPTT,AMEANT,ASIGT)
      IDAC   = IDA
      IDBC   = IDB
      NDIM   = NDIMT
      NWPPT  = NWPPTT
      NPNT   = NPNTT
      NBPPT  = NBPPTT
      NWDAT  = NINT(RDAT(NPTRH+2))
      NHDATE = NHDATT
      NHTIME = NHTIMT
      EDENT  = EDENTT
      NSDATE = NSDATT
      NSTIME = NSTIMT
      NTMODE = NTMODT
      EDLO   = EDLOT
      EDHI   = EDHIT
      CALL UCOPY_i(IDBINT,IDBIN,IABS(NDIM))
      CALL UCOPY_r(ADLOT,ADLO,IABS(NDIM))
      CALL UCOPY_r(ADHIT,ADHI,IABS(NDIM))
      CALL UCOPY_r(AMEANT,AMEAN,IABS(NDIM))
      CALL UCOPY_r(ASIGT,ASIG,IABS(NDIM))
C
 9000 CONTINUE
      NHC = NHD
      RETURN
      END
