      SUBROUTINE MN_LDP(NLI,QNEW,NMODE,IDAI,IDBI)
C
C     Does the real drawing of items
C     Mode -1 means draw now
C           0 means draw everything regardless of the flag
C           1 means draw with flag 0 in plot coordinates
C           2 means draw with flag 1 in plot coordinates
C          11 means draw with flag 0 in cm coordinates
C          12 means draw with flag 1 in cm coordinates
C
      IMPLICIT NONE
C
#include "mnpar.inc"
#include "mnhpj.inc"
#include "mncmd.inc"
#include "mnprs.inc"
#include "mnpij.inc"
C
      INTEGER NLI,NMODE,idai,idbi
      LOGICAL QNEW
C
      REAL XPT(MCPNT+4),YPT(MCPNT+4)
      REAL XA(2),YA(2)
      INTEGER NA,I,IERR,NL,NL1,NL2,NSEGM
      REAL THETA,THE3,THE4,RAD1,RAD2,PHI1,PHI2
      INTEGER NSYM,NsCOL,nhcol,npcol
     + ,JMODE,NHAT,NPAT,NATYP,LMODE,IDA,IDB,NDRWTP,NPT
      REAL THICK,SINEH,SINEL,SIZE,AUNIT,XUNIT
C
      IF(NLI.LT.0) THEN
          RETURN
      ELSEIF(NLI.EQ.0) THEN
          NL1 = 1
          NL2 = NDRWLN
      ELSE
          NL1 = NLI
          NL2 = NLI
      ENDIF
C
C     IF THERE ARE NO HISTOGRAMS THEN SET UP SCREEN
C
      IF(NHPLT.LE.0 .AND. NL1.EQ.1 .AND. QNEW) THEN
          call m_spage
      ENDIF
C
*ICB      write(6,'('' MN_LDP called with mode'',I3,'' ID'',I8,I4)')
*ICB     + nmode,idai,idbi
      DO 1000 NL=NL1,NL2
          NDRWTP = IDRWTP(NL)
          NPT    = NINT(RDRWPM(20,NL))
C
          NSYM  = NINT(RDRWPM(1,NL))
          NsCOL = NINT(RDRWPM(2,NL))
          THICK = RDRWPM(3,NL)
          JMODE = NINT(RDRWPM(4,NL))
          NHAT  = NINT(RDRWPM(5,NL))
          NPAT  = NINT(RDRWPM(6,NL))
          SINEH = RDRWPM(5,NL)
          SINEL = RDRWPM(6,NL)
          NATYP = NINT(RDRWPM(5,NL))
          IF(NATYP.EQ.0) NATYP = 1
          LMODE = NINT(RDRWPM(7,NL))
          NhCOL = NINT(RDRWPM(8,NL))
          NpCOL = NINT(RDRWPM(9,NL))
          SIZE  = TSZES(4)
          AUNIT = TSZES(5)
          IDA   = NINT(RDRWPM(18,NL))
          IDB   = NINT(RDRWPM(19,NL))
C
C         See if this should be drawn now
C
          if(nmode.eq.01 .and. (jmode.ne.1 .or. lmode.ne.0)) goto 1000
          if(nmode.eq.02 .and. (jmode.ne.1 .or. lmode.ne.1)) goto 1000
          if(nmode.eq.11 .and. (jmode.ne.0 .or. lmode.ne.0)) goto 1000
          if(nmode.eq.12 .and. (jmode.ne.0 .or. lmode.ne.1)) goto 1000
          if(nmode.eq.1 .or. nmode.eq.2) then
            if(ida.ne.idai .or. idb.ne.idbi) goto 1000
          endif
*ICB          write(6,'('' Drawing item'',I3,'' with mode'',I3
*ICB     +     '' ID'',I8,I4)') nl,lmode,ida,idb
*ICB          IF((NMODE.EQ.1 .AND. LMODE.NE.1) .OR.
*ICB     +       (NMODE.EQ.0 .AND. LMODE.NE.0)) GOTO 1000
C
C         Create a segment if we are drawing all items
C
          IF(NLI.EQ.0) THEN
              NSEGM = 15000 + NL
              CALL M_CRSG(NSEGM)
          ENDIF
C
C         If this is plot mode then get the correct plot co-ordinates
C         This should no longer be necessary as the call will be made
C         from inside MN_PLT at the right point.
C
*ICB          IF(nhplt.gt.0 .and. JMODE.EQ.1) THEN
*ICB              CALL MN_PPP(IDA,IDB,IERR)
*ICB          ENDIF
C
C         LINE
C
          IF(NDRWTP.EQ.MDRW_LINE .OR. NDRWTP.EQ.MDRW_POLYLINE) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,NPT,JMODE)
              CALL MN_LIN(XPT,YPT,NPT,NSYM,AUNIT,NsCOL,THICK)
C
C         ARROW
C
          ELSE IF(NDRWTP.EQ.MDRW_ARROW) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,NPT,JMODE)
              CALL MN_LIN(XPT,YPT,NPT,NSYM,AUNIT,NsCOL,THICK)
              IF(XPT(1).EQ.XPT(2) .AND. YPT(1).EQ.YPT(2)) THEN
                  GOTO 9000
              ENDIF
C
C             Sort out where to put the arrowhead
C
              IF(IABS(NATYP).EQ.1) THEN
                  NA = 1
                  XA(1) = XPT(2)
                  YA(1) = YPT(2)
              ELSEIF(IABS(NATYP).EQ.2) THEN
                  NA = 1
                  XA(1) = XPT(1)
                  YA(1) = YPT(1)
              ELSEIF(IABS(NATYP).EQ.3) THEN
                  NA = 2
                  XA(1) = XPT(1)
                  YA(1) = YPT(1)
                  XA(2) = XPT(2)
                  YA(2) = YPT(2)
              ELSEIF(IABS(NATYP).EQ.4) THEN
                  NA = 1
                  XA(1) = 0.5 * (XPT(1) + XPT(2))
                  YA(1) = 0.5 * (YPT(1) + YPT(2))
              ELSE
                  GOTO 9000
              ENDIF
C
              DO I=1,NA
                  IF(IABS(NATYP).EQ.1 .OR. IABS(NATYP).EQ.4 .OR.
     +             (IABS(NATYP).EQ.3 .AND. I.EQ.2)) THEN
                      IF(ABS(XPT(1)-XPT(2)).LT.1.0E-10) THEN
                          THETA = PI / 2.0
                          IF(YPT(1).LT.YPT(2)) THETA = -PI / 2.0
                      ELSE IF(YPT(1).EQ.YPT(2)) THEN
                          THETA = 0.0
                          IF(XPT(1).LT.XPT(2)) THETA = PI
                      ELSE
                          THETA = ATAN2(YPT(1)-YPT(2),XPT(1)-XPT(2))
                      ENDIF
                  ELSE
                      IF(ABS(XPT(1)-XPT(2)).LT.1.0E-10) THEN
                          THETA = PI / 2.0
                          IF(YPT(2).LT.YPT(1)) THETA = -PI / 2.0
                      ELSE IF(YPT(1).EQ.YPT(2)) THEN
                          THETA = 0.0
                          IF(XPT(2).LT.XPT(1)) THETA = PI
                      ELSE
                          THETA = ATAN2(YPT(2)-YPT(1),XPT(2)-XPT(1))
                      ENDIF
                  ENDIF
                  THE3 = THETA + PI / 9.0
                  THE4 = THETA - PI / 9.0
                  XPT(MCPNT+1) = XA(I) + SIZE * COS(THE3)
                  YPT(MCPNT+1) = YA(I) + SIZE * SIN(THE3)
                  XPT(MCPNT+2) = XA(I)
                  YPT(MCPNT+2) = YA(I)
                  XPT(MCPNT+3) = XA(I) + SIZE * COS(THE4)
                  YPT(MCPNT+3) = YA(I) + SIZE * SIN(THE4)
                  IF(NATYP.GT.0) THEN
                      CALL MN_LIN(XPT(MCPNT+1),YPT(MCPNT+1),3,NSYM,AUNIT
     1                 ,NsCOL,THICK)
                  ELSE
                      CALL TVSHAD(2,XPT(MCPNT+1),YPT(MCPNT+1),3,100
     +                 ,NhCOL)
                  ENDIF
              ENDDO
C
C         Box
C
          ELSEIF(NDRWTP.EQ.MDRW_BOX) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL)
     +         ,XPT(MCPNT+1),YPT(MCPNT+1),2,JMODE)
              XPT(1) = XPT(MCPNT+1)
              YPT(1) = YPT(MCPNT+1)
              XPT(2) = XPT(MCPNT+2)
              YPT(2) = YPT(MCPNT+1)
              XPT(3) = XPT(MCPNT+2)
              YPT(3) = YPT(MCPNT+2)
              XPT(4) = XPT(MCPNT+1)
              YPT(4) = YPT(MCPNT+2)
              XPT(5) = XPT(1)
              YPT(5) = YPT(1)
              CALL MN_LIN(XPT,YPT,5,NSYM,AUNIT,NsCOL,THICK)
C
C             FILL WITH A PATTERN OR HATCHING
C
              IF(NHAT.NE.0) CALL TVSHAD(1,XPT,YPT,5,NHAT,NhCOL)
              IF(NPAT.NE.0) CALL TVSHAD(2,XPT,YPT,5,NPAT,NpCOL)
C
C         Triangle and Polygon
C
          ELSEIF(NDRWTP.EQ.MDRW_TRIANGLE .OR.
     +         NDRWTP.EQ.MDRW_POLYGON) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,NPT,JMODE)
              XPT(NPT+1) = XPT(1)
              YPT(NPT+1) = YPT(1)
              CALL MN_LIN(XPT,YPT,NPT+1,NSYM,AUNIT,NsCOL,THICK)
C
C             FILL WITH A PATTERN OR HATCHING
C
              IF(NHAT.NE.0) CALL TVSHAD(1,XPT,YPT,NPT+1,NHAT,NhCOL)
              IF(NPAT.NE.0) CALL TVSHAD(2,XPT,YPT,NPT+1,NPAT,NpCOL)
C
C         Circle
C
          ELSEIF(NDRWTP.EQ.MDRW_CIRCLE) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,1,JMODE)
              XPT(MCPNT+1) = XDRWPT(1,NL)
              XPT(MCPNT+2) = XDRWPT(1,NL) + XDRWPT(2,NL)
              YPT(MCPNT+1) = YDRWPT(1,NL)
              YPT(MCPNT+2) = YDRWPT(1,NL) + YDRWPT(2,NL)
              CALL MN_CTR(XPT(MCPNT+1),YPT(MCPNT+1),XPT(2),YPT(2),2
     +         ,JMODE)
              RAD1 = XPT(3) - XPT(2)
C
              CALL TVARC(XPT(1),YPT(1),0.0,RAD1,0.0,0.0
     +         ,NSYM,NsCOL,THICK,NHAT,NPAT,nhcol,npcol)
C
C         Arc
C
          ELSEIF(NDRWTP.EQ.MDRW_ARC) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,1,JMODE)
              XPT(MCPNT+1) = XDRWPT(1,NL)
              XPT(MCPNT+2) = XDRWPT(1,NL) + XDRWPT(2,NL)
              YPT(MCPNT+1) = YDRWPT(1,NL)
              YPT(MCPNT+2) = YDRWPT(1,NL) + YDRWPT(2,NL)
              CALL MN_CTR(XPT(MCPNT+1),YPT(MCPNT+1),XPT(2),YPT(2),2
     +         ,JMODE)
              RAD1 = XPT(3) - XPT(2)
              RAD2 = YPT(3) - YPT(2)
              PHI1 = XDRWPT(3,NL)
              PHI2 = YDRWPT(3,NL)
C
              CALL TVARC(XPT(1),YPT(1),RAD1,RAD2,PHI1,PHI2
     +         ,NSYM,NsCOL,THICK,NHAT,NPAT,nhcol,npcol)
C
C         Sine Wave - photons
C
          ELSEIF(NDRWTP.EQ.MDRW_SINE) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,NPT,JMODE)
              CALL MN_SIN(XPT,YPT,NPT,NSYM,SINEH,SINEL,NsCOL,THICK)
C
C         Gluon
C
          ELSEIF(NDRWTP.EQ.MDRW_GLUON) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,NPT,JMODE)
              CALL MN_GLU(XPT,YPT,NPT,NSYM,SINEH,SINEL,NsCOL,THICK)
C
C         Symbol
C
          ELSEIF(NDRWTP.EQ.MDRW_SYMBOL) THEN
              SIZE  = THICK
              THICK = ATHKS(7)
              XUNIT = TSZES(5)
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,1,JMODE)
              CALL MN_SYM(NSYM,XPT,YPT,0.0,0.0,0.0,0.0
     +         ,SIZE,SIZE,NsCOL,nscol,THICK,XUNIT,-1)
C
C         Ellipse
C
          ELSEIF(NDRWTP.EQ.MDRW_ELLIPSE) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,1,JMODE)
              XPT(MCPNT+1) = XDRWPT(1,NL)
              XPT(MCPNT+2) = XDRWPT(1,NL) + XDRWPT(2,NL)
              YPT(MCPNT+1) = YDRWPT(1,NL)
              YPT(MCPNT+2) = YDRWPT(1,NL) + YDRWPT(2,NL)
              CALL MN_CTR(XPT(MCPNT+1),YPT(MCPNT+1),XPT(2),YPT(2),2
     +         ,JMODE)
              RAD1 = XPT(3) - XPT(2)
              RAD2 = YPT(3) - YPT(2)
              PHI1 = XDRWPT(3,NL)
C
              CALL TVELL(XPT(1),YPT(1),RAD1,RAD2,PHI1,0.0
     +         ,NSYM,NsCOL,THICK,NHAT,NPAT,nhcol,npcol)
C
C         Segment
C
          ELSEIF(NDRWTP.EQ.MDRW_SEG) THEN
              CALL MN_CTR(XDRWPT(1,NL),YDRWPT(1,NL),XPT,YPT,2,JMODE)
              XPT(MCPNT+1) = XDRWPT(1,NL)
              XPT(MCPNT+2) = XDRWPT(1,NL) + XDRWPT(3,NL)
              YPT(MCPNT+1) = YDRWPT(1,NL)
              YPT(MCPNT+2) = YDRWPT(1,NL)
              CALL MN_CTR(XPT(MCPNT+1),YPT(MCPNT+1),XPT(3),YPT(3),2
     +         ,JMODE)
              RAD1 = XPT(4) - XPT(3)
C
              CALL TVSEG(XPT(1),YPT(1),rad1
     +         ,nsym,nscol,thick,nhat,npat,nhcol,npcol)
          ENDIF
C
C         Close the segment if we are drawing all items
C
          IF(NLI.EQ.0) THEN
              CALL M_CLSG(NSEGM)
          ENDIF
C
 1000 CONTINUE
C
 9000 CONTINUE
      IF(NMODE.EQ.-1) CALL TVSHOW
      END
