C
      SUBROUTINE MN_PRN(IDA1,IDA2,IDB1,IDB2,NNID,NMODE)
C
C     DETAILED MN_FIT ROUTINE FOR PRINTING HISTOGRAMS
C     NMODE = 0 MEANS ROUTINE IS CALLED FROM MN_FIT
C     NMODE = 1 MEANS ROUTINE IS CALLED FROM MNBOOK
C
#include "mnpar.inc"
#include "mndat.inc"
#include "mninf.inc"
#include "mncmd.inc"
#include "mnlun.inc"
C
      LOGICAL QMNHEX,HEXIST,QEXIST,QHEXST
      LOGICAL QRNGE
C
      IF(IDA1.NE.0 .AND. IDA1.EQ.IDA2 .AND. IDB1.EQ.IDB2) THEN
          NH = 0
          QEXIST = QMNHEX(IDA1,IDB1,NH)
          IF(.NOT.QEXIST) THEN
              WRITE(LUNTTO
     1         ,'('' Histogram'',I7,I4,'' does not exist'')')
     2         IDA1,IDB1
              GOTO 9000
          ENDIF
          NH1 = NH
          NH2 = NH
          QRNGE = .FALSE.
      ELSE
          NH1 = 1
          NH2 = NDHIS
          QRNGE = .TRUE.
      ENDIF
C
      DO 2500 NH=NH1,NH2
          IDA = IDIDA(NH)
          IDB = IDIDB(NH)
          IF(IDPTRH(NH).LE.0 .OR. IDPTRD(NH).LE.0) GOTO 2500
          IF(QRNGE .AND. IDA1.NE.0 .AND.
     1       (IDA.LT.IDA1 .OR. IDA.GT.IDA2 .OR.
     2        IDB.LT.IDB1 .OR. IDB.GT.IDB2)) GOTO 2500
C
          CALL MN_HGT(IDA,IDB,NHD)
C     +     ,NPTRH,NPTRD,NDIM,NWPPT,NPNT
C     1     ,EDENT,EDLO,EDHI,IDBIN,ADLO,ADHI,NBPPT)
          IF(NHD.LE.0) THEN
              WRITE(TXTERR,'(''Histogram'',I7,I4
     2          ,'' does not exist'')') IDA,IDB
              CALL M_EMSG('MN_PRN',TXTERR)
              IF(.NOT.QRNGE) GOTO 9000
              GOTO 2500
          ENDIF
          IF(.NOT.QRNGE .AND. NDIM.EQ.-1) THEN
              IF(TDDIR(NHD).NE.'//MN_HBIN') THEN
                  WRITE(TXTERR,'(''Histogram'',I7,I4,'':''
     1             ,'' I cannot print a series of data points'')')
     +             IDA,IDB
                  CALL M_EMSG('MN_PRN',TXTERR)
                  GOTO 2500
              ENDIF
          ELSEIF(.NOT.QRNGE .AND. NDIM.LE.0) THEN
              WRITE(TXTERR,'(''Histogram'',I7,I4,'':''
     1         ,'' I cannot print scatter plots'')') IDA,IDB
              CALL M_EMSG('MN_PRN',TXTERR)
              GOTO 2500
          ELSEIF(.NOT.QRNGE .AND. NDIM.GT.2) THEN
              WRITE(TXTERR,'(''Histogram'',I7,I4,'':''
     1         ,'' I cannot print histograms with more''
     1         ,'' than 2 dimensions'')') IDA,IDB
              CALL M_EMSG('MN_PRN',TXTERR)
               GOTO 2500
          ENDIF
C
cicb          IDH = IDB*1000 + IDA
          IDH = IDA
          QHEXST = .FALSE.
          QEXIST = .FALSE.
          IF(NMODE.EQ.1 .AND. HEXIST(IDH)) THEN
              QHEXST = .TRUE.
              CALL HCOPY(IDH,987654,' ')
              CALL HDELET(IDH)
          ENDIF
C
          IF(NMODE.EQ.0 .OR. NMODE.EQ.1) THEN
              CALL MN_HBN(IDA,IDB,IERR)
              IF(.NOT.HEXIST(IDH)) GOTO 2500
              QEXIST = .TRUE.
          ENDIF
C
C         PRINT THE HISTOGRAM
C
          IF(NMODE.EQ.0) THEN
              IF(LUNDMP.EQ.LUNTTO) THEN
                  NLINE = 31
              ELSE
                  NLINE = 61
              ENDIF
              CALL HPAGSZ(NLINE)
              CALL HIDOPT(IDH,'ROTA')
          ENDIF
C
          CALL HPRINT(IDH)
C
          IF(QEXIST) THEN
              CALL HDELET(IDH)
          ENDIF
C
          IF(QHEXST) THEN
              CALL HCOPY(987654,IDH,' ')
              CALL HDELET(987654)
          ENDIF
2500  CONTINUE
C
9000  CONTINUE
      RETURN
      END
