      SUBROUTINE MN_WND(NMODE,IDELIM,QPLOT,NPS1,NPS2)
C
C     SETS UP WINDOWING
C
C     NMODE = -1 MEANS TURN OFF WINDOWING
C     NMODE =  0 MEANS CHANGE CURRENT WINDOW NUMBER
C     NMODE =  1 MEANS SET UP FOR WINDOWING
C
#include "mnpar.inc"
#include "mncmd.inc"
#include "mnhpj.inc"
#include "mnlun.inc"
C
      INTEGER INUM(10)
      LOGICAL QPLOT
C
C     TURN OFF WINDOWING
C
      IF(NMODE.EQ.-1) THEN
          QWIND  = .FALSE.
          IPWNDS(1) = 0
          IPWNDS(2) = 0
          IWIND(1) = 1
          IWIND(2) = 1
          IF(QDFIT) THEN
              QPWIND = .FALSE.
              IPWIND(1) = 1
              IPWIND(2) = 1
          ENDIF
C
C         SET THE TITLE AND SCALE BACK TO DEFAULT SIZE
C
          TITLS(3)   = TITLD(3)
          SCALS(3,1) = SCALD(3,1)
          SCALS(3,2) = SCALD(3,2)
          SCALS(3,3) = SCALD(3,3)
          TICKS(4,1) = TICKD(4,1)
          TICKS(4,2) = TICKD(4,2)
          TICKS(4,3) = TICKD(4,3)
          TICKS(5,1) = TICKD(5,1)
          TICKS(5,2) = TICKD(5,2)
          TICKS(5,3) = TICKD(5,3)
          SCALS(2,1) = SCALD(2,1)
          alabls(3,1)= alabld(3,1)
          alabls(3,2)= alabld(3,2)
          alabls(3,3)= alabld(3,3)
          alabls(1,1)= alabld(1,1)
          alabls(2,1)= alabld(2,1)
          alabls(1,2)= alabld(1,2)
          alabls(2,2)= alabld(2,2)
          alabls(1,3)= alabld(1,3)
          alabls(2,3)= alabld(2,3)
C
C     CHANGE THE CURRENT WINDOW NUMBER
C
      ELSE IF(NMODE.EQ.0) THEN
          NNUM = 0
 2000     CONTINUE
          IF(QPLOT) THEN
              CALL WAITYQ('Give x and y window numbers for plot: ')
          ELSE
              CALL WAITYQ(
     1         'Give x and y window numbers for next plot: ')
          ENDIF
          NVAL = IVLTYQ(.TRUE.,IDELIM)
          CALL MN_NCK(NVAL,IDELIM,IERR)
          IF(IERR.GT.0) GOTO 9000
C
          NNUM = NNUM + 1
          INUM(NNUM) = NVAL
          IF(NNUM.LT.2 .AND. IDELIM.EQ.0) GOTO 2000
C
          IF(INUM(1).LE.0 .OR. INUM(1).GT.IWIND(1) .OR.
     1       INUM(2).LE.0 .OR. INUM(2).GT.IWIND(2)) THEN
              WRITE(LUNTTO,'('' Invalid window number'',2I4
     1         ,'' It will be set to'',2I4)')
     1         INUM(1),INUM(2),IPWNDS(1),IPWNDS(2)
              INUM(1) = IPWNDS(1)
              INUM(2) = IPWNDS(2)
          ENDIF
C
          IF(QPLOT) THEN
              DO 2100 NP=NPS1,NPS2
                  DO 2050 II=1,2
                      IPWNDP(II,NP) = INUM(II)
C
C                     RECALCULATE THE CORNER POSITION OF THE PLOT
C
                      WMRGP(II,NP) = FLOAT(IPWNDP(II,NP)) *
     1                 (WSPACE(II) + WSZEP(II,NP))
2050              CONTINUE
2100          CONTINUE
          ELSE
              IF(INUM(1).GT.1) THEN
                  INUM(1) = INUM(1) - 1
              ELSE IF(INUM(2).GT.1) THEN
                  INUM(2) = INUM(2) - 1
                  INUM(1) = IWIND(1)
              ELSE
                  INUM(1) = 0
                  INUM(2) = 0
              ENDIF
              IPWNDS(1) = INUM(1)
              IPWNDS(2) = INUM(2)
          ENDIF
C
C     SET UP FOR WINDOWING
C
      ELSE IF(NMODE.EQ.1) THEN
C
C         IF LAST PLOT WAS A FIT GET BACK THE PARAMETERS FOR
C         A NORMAL PLOT
C
          IF(QDFIT) CALL MN_FRP
C
          NNUM = 0
          IF(.NOT.QRFILE .AND. IDELIM.LT.0) THEN
              WRITE(LUNTTO,'('' Present numbers of windows are''
     1         ,'' x='',I2,''  y='',I2
     2         ,/,'' Hit <CR> to keep these numbers'')')
     3         IWIND(1),IWIND(2)
          ENDIF
 3000     CONTINUE
          CALL WAITYQ('Give number of windows' //
     1     ' in x and y directions: ')
          NVAL = INTTYQ(.TRUE.,IDELIM)
          CALL MN_NCK(NVAL,IDELIM,IERR)
          IF(IERR.EQ.2) GOTO 3100
          IF(IERR.GT.0) THEN
              IF(QRFILE) THEN
                  GOTO 3100
              ELSE
                  NNUM = 0
                  CALL ZERTYQ('.FALSE.')
                  GOTO 3000
              ENDIF
          ENDIF
          NNUM = NNUM + 1
          IWIND(NNUM)  = NVAL
          IPWIND(NNUM) = NVAL
          IF(IDELIM.EQ.0 .AND. NNUM.LT.2) GOTO 3000
C
 3100     CONTINUE
          NNUM = 0
          IF(QRFILE .AND. IDELIM.LT.0) THEN
              WRITE(LUNTTO,'('' Present separations between plots are''
     1         ,'' x='',F7.2,''  y='',F7.2
     2         ,/,'' Hit <CR> to keep these separations'')')
     3         WSPACE(1),WSPACE(2)
          ENDIF
 3200     CONTINUE
          CALL WAITYQ('Give separation between plots' //
     1     ' in x and y directions: ')
          RVAL = RELTYQ(.TRUE.,IDELIM)
          CALL MN_RCK(RVAL,IDELIM,IERR)
          IF(IERR.EQ.2) GOTO 3300
          IF(IERR.GT.0) THEN
              IF(QRFILE) THEN
                  CALL RESTYQ
                  GOTO 3300
              ELSE
                  NNUM = 0
                  CALL ZERTYQ('.FALSE.')
                  GOTO 3200
              ENDIF
          ENDIF
          NNUM = NNUM + 1
          WSPACE(NNUM) = RVAL
          WPSPAC(NNUM) = RVAL
          IF(IDELIM.EQ.0 .AND. NNUM.LT.2) GOTO 3200
C
C         CHECK THAT THE NEXT WINDOW NUMBER IS REASONABLE AND
C         WHETHER WE ARE REALLY STILL WINDOWING
C
3300      CONTINUE
          DO 3310 NAX=1,2
              IF(IWIND(NAX).LE.0) THEN
                  IWIND(NAX)  = 1
                  IPWIND(NAX) = 1
              ENDIF
3310      CONTINUE
C
          IF(IWIND(1).GT.1 .OR. IWIND(2).GT.1) THEN
              QWIND = .TRUE.
              QPWIND = .TRUE.
C
C             Set the next window number to 1,1.
C             If you do not like this use SET NEXT_WINDOW to change again
C
              IPWNDS(1) = 0
              IPWNDS(2) = 0
cicb              IF(IPWNDS(1).GT.IWIND(1) .OR. IPWNDS(2).GT.IWIND(2) .OR.
cicb     1           (IWIND(1).EQ.1 .AND. IWIND(2).EQ.1)) THEN
cicb                  IPWNDS(1) = 0
cicb                  IPWNDS(2) = 0
cicb              ENDIF
C
C             SET UP THE PLOT SIZES AND MARGINS IN THE WINDOW
C
              DO 3400 NAX=1,2
                  WMRGS(NAX) = 0.0
                  WSZES(NAX)   = (HSZES(NAX) -
     1             FLOAT(IWIND(NAX)-1)*WSPACE(NAX)) / FLOAT(IWIND(NAX))
3400          CONTINUE
C
C             Change the title, tick and scale sizes if necessary
C             Also change the scale spacing from the x-axis and the
C             title offset in y
C
              IF(IWIND(1).GT.1 .and. qascal) THEN
                  AW1 = FLOAT(IWIND(1))
                  AW2 = FLOAT(IWIND(2))
                  IF(.NOT.QTUSER .AND.
     1               ABS(TITLS(3)-TITLD(3)).LT.1.0E-03) THEN
                      TITLS(3) = AMAX1(TITLS(3)/AW1,0.20)
                  ENDIF
                  IF(.NOT.QTUSER .AND.
     1               ABS(TITLS(2)-TITLD(2)).LT.1.0E-03) THEN
                      TITLS(2) = AMAX1(TITLS(2)/AW1,0.20)
                  ENDIF
*                 Tick sizes
                  IF(ABS(TICKS(4,1)-TICKD(4,1)).LT.1.0E-03 .AND.
     1               ABS(TICKS(5,1)-TICKD(5,1)).LT.1.0E-03 .AND.
     1               ABS(TICKS(4,2)-TICKD(4,2)).LT.1.0E-03 .AND.
     1               ABS(TICKS(5,2)-TICKD(5,2)).LT.1.0E-03)THEN
                      TICKS(4,1) = AMAX1(TICKS(4,1)/(0.66*AW1),0.10)
                      TICKS(4,2) = TICKS(4,1)
                      TICKS(4,3) = TICKS(4,1)
                      TICKS(5,1) = AMAX1(TICKS(5,1)/(0.66*AW1),0.20)
                      TICKS(5,2) = TICKS(5,1)
                      TICKS(5,3) = TICKS(5,1)
                  ENDIF
*                 Scale sizes
                  IF(ABS(SCALS(3,1)-SCALD(3,1)).LT.1.0E-03 .AND.
     1               ABS(SCALS(3,2)-SCALD(3,2)).LT.1.0E-03) THEN
                      SCALS(3,1) = AMAX1(SCALS(3,1)/(0.66*AW1),0.25)
                      SCALS(3,2) = SCALS(3,1)
                      SCALS(3,3) = SCALS(3,1)
                  ENDIF
*                 Offset of scale on x-axis
                  IF(IWIND(2).GT.1 .AND.
     +               ABS(SCALS(2,1)-SCALD(2,1)).LT.1.0E-03) THEN
                      SCALS(2,1) = SCALS(2,1)/(0.66*AW2)
                  ENDIF
*                 Label sizes
                  IF(ABS(alablS(3,1)-alablD(3,1)).LT.1.0E-03 .AND.
     1               ABS(alablS(3,2)-alablD(3,2)).LT.1.0E-03) THEN
                      alablS(3,1) = AMAX1(alablS(3,1)/(0.66*AW1),0.25)
                      alablS(3,2) = alablS(3,1)
                      alablS(3,3) = alablS(3,1)
                  ENDIF
*                 Offset of label on all axes
                  IF(IWIND(2).GT.1 .AND.
     +               ABS(ALABLS(2,1)-ALABLD(2,1)).LT.1.0E-03) THEN
                      ALABLS(1,1) = ALABLS(1,1)/(0.66*AW2)
                      ALABLS(2,1) = ALABLS(2,1)/(0.66*AW2)
                  ENDIF
                  IF(IWIND(2).GT.1 .AND.
     +               ABS(ALABLS(1,2)-ALABLD(1,2)).LT.1.0E-03) THEN
                      ALABLS(1,2) = ALABLS(1,2)/(0.66*AW2)
                      ALABLS(2,2) = ALABLS(2,2)/(0.66*AW2)
                  ENDIF
                  IF(IWIND(2).GT.1 .AND.
     +               ABS(ALABLS(1,3)-ALABLD(1,3)).LT.1.0E-03) THEN
                      ALABLS(1,3) = ALABLS(1,3)/(0.66*AW2)
                      ALABLS(2,3) = ALABLS(2,3)/(0.66*AW2)
                  ENDIF
              ENDIF
C
          ELSEif(iwind(1).eq.1) then
              QWIND  = .FALSE.
              QPWIND = .FALSE.
C
C             SET THE TITLE AND SCALE BACK TO DEFAULT SIZE
C
              TITLS(3)   = TITLD(3)
              SCALS(3,1) = SCALD(3,1)
              SCALS(3,2) = SCALD(3,2)
              SCALS(3,3) = SCALD(3,3)
              TICKS(4,1) = TICKD(4,1)
              TICKS(4,2) = TICKD(4,2)
              TICKS(4,3) = TICKD(4,3)
              TICKS(5,1) = TICKD(5,1)
              TICKS(5,2) = TICKD(5,2)
              TICKS(5,3) = TICKD(5,3)
              SCALS(2,1) = SCALD(2,1)
              alabls(3,1)= alabld(3,1)
              alabls(3,2)= alabld(3,2)
              alabls(3,3)= alabld(3,3)
              alabls(1,1)= alabld(1,1)
              alabls(2,1)= alabld(2,1)
              alabls(1,2)= alabld(1,2)
              alabls(2,2)= alabld(2,2)
              alabls(1,3)= alabld(1,3)
              alabls(2,3)= alabld(2,3)
          ENDIF
      ENDIF
C
9000  CONTINUE
      RETURN
      END
