      SUBROUTINE M_INTP(IDA,IDB,NH,IERR)
*
*-----------------------------------------------------------------------
*
*     Makes sure that the filenames and HBOOK directories are setup
*     properly for an Ntuple
*
*     Called by AMNP,M_NTPSCN,M_NTPPNT,MN_DMP,M_HBMN,MN_PRJ
*
*-----------------------------------------------------------------------
*
      implicit none
*
#include "mnpar.inc"
#include "mndat.inc"
#include "mninf.inc"
#include "mncwn.inc"
#include "mnflg.inc"
#include "mndbg.inc"
#include "mnlun.inc"
C
      integer ida,idb,nh,ierr
C
      integer idh,icycle,idelim
      integer lend,lenf,lnblnk
      logical hexist
      external hexist
*
*     Negative nh means that the Ntuple should not actually be fetched
*     This is used in MN_PRJ to avoid fetching big Ntuples twice.
*
      if(nh.lt.0) return
*
      if(nh.eq.0) then
          ierr = -1
          goto 9000
      endif
*
      IDH = IDA
      IF(HEXIST(IDH)) CALL HDELET(IDH)
*
*icb      IF(TDFIL(NH).NE.FIL_HB .and. tdfil(nh)(2:).ne.fil_hb .AND.
      IF(TDFIL(NH).NE.FIL_HB .and.
     +   TDFIL(NH).NE.' ') THEN
          IF(FIL_HB.NE.' ') then
              call m_hclean(1)
          endif
          FIL_HB = TDFIL(NH)
          CALL MN_FIL(44,LUNHIN,FIL_HB,IDELIM,IERR)
          IF(IERR.NE.0) GOTO 9000
      ENDIF
*
*icb      DIR_HB = DIR_HC
      DIR_HB = tddir(nh)
      CALL M_SDIR(0,IERR)
      IF(IERR.NE.0) GOTO 9000
*
      lend = max0(1,lnblnk(tddir(nh)))
      lenf = max0(1,lnblnk(fil_hb))
      if(qdebug) write(6,'('' +++ M_INTP: Rereading Ntuple'',I8
     + ,'', Dir: '',A,/,'' +++ File: '',A)')
     + idh,tddir(nh)(:lend),fil_hb(:lenf)
      ICYCLE = 99999
      CALL HRIN(IDH,ICYCLE,0)
*
 9000 CONTINUE
      END





