      SUBROUTINE MN_CDP(NMODE)
C
C     SUBROUTINE FOR DUMPING THE CUTS IN FORCE
C     NMODE > 0 means dump that cut number
C           = 0 means dump all cuts
C           < 0 means dump all cuts
C
      IMPLICIT NONE
*
#include "mnpar.inc"
#include "mncut.inc"
#include "mncmd.inc"
#include "mnlun.inc"
#include "slate.inc"
C
      INTEGER NMODE
      CHARACTER*10 TPARIN,TPAROU
      CHARACTER*5  TTAND
      INTEGER NDEP,NDEPL,NN,NC,NC1,NC2,IOERR,LEN1,LNBLNK
     + ,NPARI,NPARO,N1,N2,II
      CHARACTER TEXT*1023
C
      NDEP  = 0
      NDEPL = 0
      IF(NMODE.LE.0) THEN
          NC1 = 1
          NC2 = NCCUT
      ELSE
          NC1 = NMODE
          NC2 = NMODE
          IF(NMODE.GT.NCCUT) THEN
              WRITE(TXTERR,'(''Cut'',I4,'' does not exist'')') NMODE
              CALL MN_ERR('MN_CDP',TXTERR)
              GOTO 9000
          ENDIF
      ENDIF
C
      IF(NMODE.NE.0) THEN
          DO 2000 NN=NC1,NC2
              TEXT = ' '
              IF(ICTYPE(NN).GE.1 .AND. ICTYPE(NN).LE.3) THEN
                  WRITE(TXTMES,12100) NN,TCNAM(NN)
12100             FORMAT(1X,'Cut',I3,'/',A,':')
                  TEXT( 01:) = TCVAR(NN)
                  TEXT(301:) = CUTNAM(ICCOND(NN))
                  IF(ICTYPE(NN).EQ.1 .or. ictype(nn).eq.2) THEN
                      WRITE(TEXT(401:) ,'(1PG12.4)') RCVAL(1,NN)
                  ELSE
                      TEXT(401:) = TCVAL(NN)
                  ENDIF
                  CALL CSQMBL(TEXT,1,1023)
                  IF(ND.LT.60) THEN
                      TXTMES(20:) = TEXT
                  ELSE
                      TXTMES(20:) = TCVAR(NN)
                      CALL MN_MES(LUNTTO,'I',TXTMES)
                      IF(ICTYPE(NN).EQ.1 .or. ictype(nn).eq.2) THEN
                          WRITE(TXTMES,'(4X,A,1X,1PG12.4)')
     +                     CUTNAM(ICCOND(NN)),RCVAL(1,NN)
                      ELSE
                          TXTMES      = ' '
                          TXTMES( 5:) = CUTNAM(ICCOND(NN))
                          TXTMES(10:) = TCVAL(NN)
                      ENDIF
                  ENDIF
              ELSE
                  LEN1 = MIN0(55,LNBLNK(TCVAR(NN)))
                  if(len1.le.55) then
                    WRITE(TXTMES,12300) NN,TCNAM(NN),TCVAR(NN)(1:LEN1)
12300               FORMAT(1X,'Cut',I3,'/',A,':',1X,'File',1X,A)
                  else
                    WRITE(TXTMES,12301) NN,TCNAM(NN)
12301               FORMAT(1X,'Cut',I3,'/',A,':')
                    CALL MN_MES(LUNTTO,'I',TXTMES)
                    len1 = max(len1,74)
                    WRITE(TXTMES,12302) TCVAR(NN)(1:LEN1)
12302               FORMAT(1X,'File',1X,A)
                  endif
              ENDIF
              CALL MN_MES(LUNTTO,'I',TXTMES)
              NDEPL = NDEP
2000      CONTINUE
      ENDIF
C
      IF(NMODE.LE.0) THEN
          IF(NCUSE.GT.0 .AND. NMODE.LT.0) THEN
              CALL MN_MES(LUNTTO,'I',' The cut currently in use is:')
          ELSEIF(NCUSE.LE.0) THEN
              CALL MN_MES(LUNTTO,'I'
     +         ,' There are no cuts currently in use')
              GOTO 8000
          ENDIF
          DO 3000 NN=1,NCUSE
              NC = ICUSE(NN)
              NPARI = ICPARI(NN)
              NPARO = ICPARO(NN)
              NDEP = NDEP + NPARI
              TPARIN = ' '
              N1 = NDEPL + 1
              N2 = NDEPL + NPARI
              DO 2400 II=N1,N2
                  TPARIN(II:II) = '('
2400          CONTINUE
              NDEP = NDEP - NPARO
              TPAROU = ' '
              N1 = 10 - NDEPL
              N2 = 10 - NDEPL + NPARO - 1
              DO 2500 II=N1,N2
                  TPAROU(II:II) = ')'
2500          CONTINUE
              IF(NN.NE.NCUSE) THEN
                  LEN1  = LNBLNK(ANDNAM(ICAND(NN)+1))
                  TTAND = '.' // ANDNAM(ICAND(NN)+1)(:LEN1) // '.'
              ELSE
                  TTAND = ' '
              ENDIF
C
              IF(ICTYPE(NC).GE.1 .AND. ICTYPE(NC).LE.3) THEN
                  WRITE(TXTMES,'(1X,I2,'':'',1X,A)') NC,TPARIN
                  TEXT( 01:) = TCVAR(NC)
                  TEXT(301:) = CUTNAM(ICCOND(NC))
                  IF(ICTYPE(NC).EQ.1 .or. ictype(nc).eq.2) THEN
                      WRITE(TEXT(401:),'(1PG12.4)') RCVAL(1,NC)
                  ELSE
                      TEXT(401:) = TCVAL(NC)
                  ENDIF
                  CALL CSQMBL(TEXT,1,1023)
                  IF(ND.LT.50) THEN
                      TXTMES(16:) = TEXT
                  ELSE
                      TXTMES(16:) = TCVAR(NC)
                      if(lnblnk(tcvar(nc)).gt.50) txtmes(62:) = '...'
                      TXTMES(65:) = CUTNAM(ICCOND(NC))
                      CALL MN_MES(LUNTTO,'I',TXTMES)
                      TXTMES = ' '
                      IF(ICTYPE(NC).EQ.1 .or. ictype(nc).eq.2) THEN
                          WRITE(TXTMES(16:),'(1PG12.4)') RCVAL(1,NC)
                      ELSE
                          TXTMES(16:) = TCVAL(NC)
                          if(lnblnk(tcval(nc)).gt.50) txtmes(62:)='...'
                      ENDIF
                  ENDIF
              ELSE
                  LEN1 = MIN0(40,LNBLNK(TCVAL(NC)))
                  WRITE(TXTMES,13300,IOSTAT=IOERR)
     +             NC,TPARIN,TCVAL(NC)(1:LEN1),RCVAL(1,NC)
13300             FORMAT(1X,I2,':',1X,A,A,'(',F8.3,')')
              ENDIF
              TXTMES(65:) = TPAROU // ' ' // TTAND
              CALL MN_MES(LUNTTO,'I',TXTMES)
              NDEPL = NDEP
3000      CONTINUE
      ENDIF
8000  CONTINUE
      CALL MN_MES(LUNTTO,'E',' ')
C
 9000 CONTINUE
      END
