      LOGICAL FUNCTION QMNCUT(NH,QCWNTP,AVAL,NDIM)
C
C     Evaluates whether an entry passes the cuts
C
      implicit none
*
#include "mnpar.inc"
#include "mncut.inc"
#include "mncwn.inc"
C
      INTEGER NH,NDIM
      LOGICAL QCWNTP
      REAL AVAL(*)
C
      LOGICAL QCUT1(MCUTMX),QCUT2(MCUTMX),QOR,QPASS
      INTEGER IPARI1(MCUTMX),IPARI2(MCUTMX)
      INTEGER IPARO1(MCUTMX),IPARO2(MCUTMX)
      INTEGER IAND1(MCUTMX),IAND2(MCUTMX)
      REAL RCMS,CSRJCL,am_cut
      integer nvar,nval,nelem1,nelem2,ndep,mindep,maxdep,i,nn
     + ,ncut1,ncut2,npari,nparo,nand,i1
      real val1,val2
C
      QMNCUT = .TRUE.
      MINDEP = 1
      IF(ICPARI(1).LE.0) MINDEP = 0
      MAXDEP = -1
C
      NDEP = 0
      NN = 0
      DO 1000 NN=1,NCUSE
          I = ICUSE(NN)
          IF(I.LE.0 .OR. I.GT.NCCUT) GOTO 1000
          NVAR   = ICVAR(1,I)
          NVAl   = ICVAl(1,I)
          nelem1 = icvar(2,i)
          nelem2 = icval(2,i)
          NDEP   = NDEP + ICPARI(NN)
          MAXDEP = MAX0(MAXDEP,NDEP)
          NDEP   = NDEP - ICPARO(NN)
          IPARI1(NN) = ICPARI(NN)
          IPARO1(NN) = ICPARO(NN)
          IAND1(NN) = ICAND(NN)
C
C         Simple cut
C
          IF(ICTYPE(I).EQ.1) THEN
              IF(QCWNTP) THEN
                  if(ivsize(nvar).eq.4 .and. ivtype(nvar).eq.1) then
                      val1 = ar4(ivposn(nvar)+nelem1-1)
                  elseif(ivtype(nvar).eq.1 .and.
     +                 ivsize(nvar).eq.8) then
                      val1 = sngl(zr8(ivposn(nvar)+nelem1-1))
                  elseif(ivtype(nvar).eq.2 .or.
     +                 ivtype(nvar).eq.3) then
                      val1 = float(ir4(ivposn(nvar)+nelem1-1))
                  elseif(ivtype(nvar).eq.4) then
                      if(qr4(ivposn(nvar)+nelem1-1)) then
                          val1 = 1.0
                      else
                          val1 = 0.0
                      endif
                  else
                      val1 = 0.0
                  endif
              ELSE
                  VAL1 = AVAL(NVAR)
              ENDIF
              VAL2 = RCVAL(1,I)
C
C         Parsed cut
C
          ELSEIF(ICTYPE(I).EQ.2 .or. ictype(i).eq.3) THEN
              IF(NVAR.GT.0) THEN
                  if(qcwntp) then
                      if(ivtype(nvar).eq.1 .and. ivsize(nvar).eq.4) then
                          val1 = ar4(ivposn(nvar)+nelem1-1)
                      elseif(ivtype(nvar).eq.1 .and.
     +                     ivsize(nvar).eq.8) then
                          val1 = sngl(zr8(ivposn(nvar)+nelem1-1))
                      elseif(ivtype(nvar).eq.2 .or.
     +                     ivtype(nvar).eq.3) then
                          val1 = float(ir4(ivposn(nvar)+nelem1-1))
                      elseif(ivtype(nvar).eq.4) then
                          if(qr4(ivposn(nvar)+nelem1-1)) then
                              val1 = 1.0
                          else
                              val1 = 0.0
                          endif
                      else
                          val1 = 0.0
                      endif
                  else
                      VAL1 = AVAL(NVAR)
                  endif
              ELSE
                  VAL1 = AM_CUT(-NVAR)
              ENDIF
*
              if(ictype(i).eq.2) then
                  val2 = rcval(1,i)
              elseif(NVAl.GT.0) THEN
                  if(qcwntp) then
                      if(ivtype(nval).eq.1 .and. ivsize(nval).eq.4) then
                          val2 = ar4(ivposn(nval)+nelem2-1)
                      elseif(ivtype(nval).eq.1 .and.
     +                     ivsize(nval).eq.8) then
                          val2 = sngl(zr8(ivposn(nval)+nelem2-1))
                      elseif(ivtype(nval).eq.2 .or.
     +                     ivtype(nval).eq.3) then
                          val2 = float(ir4(ivposn(nval)+nelem2-1))
                      elseif(ivtype(nval).eq.4) then
                          if(qr4(ivposn(nval)+nelem2-1)) then
                              val2 = 1.0
                          else
                              val2 = 0.0
                          endif
                      else
                          val2 = 0.0
                      endif
                  else
                      VAL2 = AVAL(NVAl)
                  endif
              ELSE
                  VAL2 = AM_CUT(-NVAl)
              ENDIF
C
C         COMIS function
C
          ELSEIF(ICTYPE(I).EQ.4) THEN
              VAL2 = RCVAL(1,I)
              RCMS = CSRJCL(NVAR,1,VAL2)
              QCUT1(NN) = NINT(RCMS).NE.0
              GOTO 1000
          ENDIF
C
C         CUT IS EQ
C
          IF(ICCOND(I).EQ.1) THEN
              QCUT1(NN) = VAL1.EQ.VAL2
C
C         CUT IS NE
C
          ELSEIF(ICCOND(I).EQ.2) THEN
              QCUT1(NN) = VAL1.NE.VAL2
C
C         CUT IS LT
C
          ELSEIF(ICCOND(I).EQ.3) THEN
              QCUT1(NN) = VAL1.LT.VAL2
C
C         CUT IS LE
C
          ELSEIF(ICCOND(I).EQ.4) THEN
              QCUT1(NN) = VAL1.LE.VAL2
C
C         CUT IS GT
C
          ELSEIF(ICCOND(I).EQ.5) THEN
              QCUT1(NN) = VAL1.GT.VAL2
C
C         CUT IS GE
C
          ELSEIF(ICCOND(I).EQ.6) THEN
              QCUT1(NN) = VAL1.GE.VAL2
          ENDIF
1000  CONTINUE
C
C     IF NO CUTS BEING USED THEN RETURN
C
      IF(MAXDEP.LT.MINDEP) RETURN
C
      NCUT1 = NCUSE
C
 2000 CONTINUE
      QOR = .FALSE.
      QPASS = .FALSE.
      NN = 0
      NDEP  = 0
      DO 2500 I=1,NCUT1
          NPARI = IPARI1(I)
          NPARO = IPARO1(I)
          NDEP  = NDEP + IPARI1(I)
          NAND  = IAND1(I)
          IF(NDEP.LT.MAXDEP) THEN
              NN = NN + 1
              QCUT2(NN)  = QCUT1(I)
              IPARI2(NN) = IPARI1(I)
              IPARO2(NN) = IPARO1(I)
              IAND2(NN)  = IAND1(I)
          ELSE
              IF(I.EQ.1 .OR. NPARI.GT.0) THEN
                  QPASS = QCUT1(I)
                  QOR   = IAND1(I).EQ.1
                  I1    = I
              ELSE
                  IF(QOR .AND. QCUT1(I)) THEN
                      QPASS = .TRUE.
                  ELSEIF(.NOT.QOR .AND. .NOT.QCUT1(I)) THEN
                      QPASS = .FALSE.
                  ENDIF
              ENDIF
C
              IF(NPARO.GT.0) THEN
                  NN = NN + 1
                  QCUT2(NN) = QPASS
                  IPARI2(NN)= IPARI1(I1) - 1
                  IPARO2(NN)= IPARO1(I)  - 1
                  IAND2(NN) = NAND
              ENDIF
          ENDIF
          NDEP = NDEP - IPARO1(I)
 2500 CONTINUE
C
      MAXDEP = MAXDEP - 1
      IF(MAXDEP.LT.MINDEP) THEN
          QMNCUT = QPASS
          GOTO 3000
      ENDIF
C
      NCUT2 = NN
      CALL QCOPY(QCUT2,QCUT1,NCUT2)
      CALL UCOPY_i(IPARI2,IPARI1,NCUT2)
      CALL UCOPY_i(IPARO2,IPARO1,NCUT2)
      CALL UCOPY_i(IAND2,IAND1,NCUT2)
      NCUT1 = NCUT2
      GOTO 2000
C
 3000 CONTINUE
C
 9000 CONTINUE
      RETURN
      END
