      SUBROUTINE MN_CLC
C
C     ROUTINES THAT ALLOW ACCESS TO PARAMETERS, REGISTERS, BIN CONTENTS ETC
C
      implicit none
*
#include "mnpar.inc"
#include "mndat.inc"
#include "mninf.inc"
#include "mnfun.inc"
#include "mnprs.inc"
#include "mnfit.inc"
#include "mnusr.inc"
#include "mncmd.inc"
#include "mntyq.inc"
#include "mnlun.inc"
C
      LOGICAL QPASS
C
      CHARACTER*10 COMAND
      CHARACTER*20  CTEMP
      real xbinsv,ybinsv,x
      integer lenc,lenv,lent,leng,istr,iequl,icmd,idelim,nchar,nerr
      integer ireg,ifun,ipar,iset,ibin,ivar
     + ,ida,idb,nh,ndimd,nwpptd,nbpptd,nwdatd
*
      integer  lnblnk
      integer  istrng
      real     am_exp
      external lnblnk,istrng,am_exp
C
C     Calculate Fortran arithmetic expressions
C
C     Save the delimiter and the bin width no matter what!
      TSVSCN = TSDSCN
      xbinsv = xbinnm
      ybinsv = ybinnm
      IF(.NOT.QFBINW .OR. XBINNM.LE.0.0) XBINNM = 1.0
      IF(.NOT.QFBINW .OR. YBINNM.LE.0.0) YBINNM = 1.0
C
C     Get the string to evaluate
C
      ISTR = ISTRNG(.TRUE.,STRING,NCHAR)
C
C     See if equal sign is present
C
      IEQUL = INDEX(STRING,'=')
      IF(IEQUL .GT. 0) THEN
C
C         Increase list of standard delimiters
C
          TSDSCN = ',()[]{}&'
          LENT   = LNBLNK(TSDSCN)
          CALL SDLSCN(TSDSCN(1:LENT))
C
          lenv = len(varnam(1))
          CTEMP = STRING(1:min(lenv,IEQUL-1))
          call cltou(ctemp)
          CALL QUOTYP(STRING(1:IEQUL-1))
          CALL WAITYP('Expression: ')
C
          CALL M_CGET(-1,COMAND,ICMD,IDELIM)
          IF(ICMD.LE.0 .OR. IDELIM.GT.0) GOTO 9000
C
C         A variable
C
          IF(ICMD.GT.MDEPI) THEN
              IREG = ICMD - MDEPI + MVAR0
C
C         Register
C
          ELSEIF(COMAND .EQ. 'R' .OR. COMAND.EQ.'IR') THEN
              CALL RESTYP
              CALL M_RGET(-1,COMAND,IREG,QPASS,IDELIM)
              IF(.NOT.QPASS) GOTO 9000
C
C         Parameter
C
          ELSE IF(COMAND .EQ. 'P' .OR. COMAND.EQ.'ERR' .OR.
     +            COMAND.EQ.'ERP' .OR. COMAND.EQ.'ERN' .OR.
     +            COMAND.EQ.'LOLIM' .OR. COMAND.EQ.'HILIM') THEN
              CALL RESTYP
              CALL M_PGET(-1,COMAND,IFUN,IPAR,QPASS,IDELIM)
              IF(.NOT.QPASS) GOTO 9000
C
C         X, DX, Y, DY data value
C
          ELSE IF(COMAND.EQ.'X'   .OR. COMAND.EQ.'Y'   .OR.
     +            COMAND.EQ.'DX'  .OR. COMAND.EQ.'DY'  .OR.
     +            COMAND.EQ.'DNX' .OR. COMAND.EQ.'DNY' .OR.
     +            COMAND.EQ.'DPX' .OR. COMAND.EQ.'DPY') THEN
              CALL RESTYP
              CALL M_HGET(-1,COMAND,ISET,IBIN,IVAR,QPASS,IDELIM)
              IF(.NOT.QPASS) GOTO 9000
              IF(IVAR.EQ.0) IVAR = 1
C
C             GET ALL THE RELEVANT HISTOGRAM INFORMATION
C
              IDA = IDIDA(ISET)
              IDB = IDIDB(ISET)
              CALL MN_HGT(IDA,IDB,NH)
              NDIMD  = NDIM
              NWPPTD = NWPPT
              NBPPTD = NBPPT
              NWDATD = NWDAT
              IF(IVAR.GT.0 .AND. NWDATD.LE.0) THEN
                  WRITE(TXTERR,'(''Ntuple'',I7,I4
     +             ,'' is not in memory'')') IDA,IDB
                  CALL M_EMSG('MN_CLC',TXTERR)
                  CALL MN_ERR('MN_CLC','You cannot modify it')
                  GOTO 9000
              ENDIF
          ENDIF
C
C     No "=" in expression, put it in register 0
C
      ELSE
          CTEMP  = 'R0'
          COMAND = 'R'
          IREG   = 0
      ENDIF
C
      TSDSCN = TSVSCN
      LENT   = LNBLNK(TSDSCN)
      CALL SDLSCN(TSDSCN(1:LENT))
C
      CALL M_PRSE(.FALSE.,LENG,STRING(IEQUL+1:),ISTYP,ISTP,ISTF,ISTV
     + ,QPASS)
C
C     Store it
C
      IF(QPASS) THEN
          X = AM_EXP(LENG,ISTYP,ISTP,ISTF,ISTV)
C
C         A register
C
          IF(COMAND .EQ. 'R') THEN
              REGIS(IREG) = X
          ELSEIF(COMAND .EQ. 'IR') THEN
              REGIS(IREG) = X
C
C         A parameter. Update the MINUIT parameter list also if necessary
C
          ELSE IF(COMAND .EQ. 'P') THEN
              IF(IFUN.GT.0) THEN
                  FPAR(IPAR,IFUN)   = X
              ELSE
                  F00               = X
              ENDIF
              CALL M_MINU(IPAR,IFUN)
          ELSE IF(COMAND .EQ. 'ERR') THEN
              IF(IFUN.GT.0) THEN
                  DFPAR(IPAR,IFUN)  = X
              ELSE
                  DF00              = X
              ENDIF
              CALL M_MINU(IPAR,IFUN)
          ELSE IF(COMAND .EQ. 'ERP') THEN
              IF(IFUN.GT.0) THEN
                  DPFPAR(IPAR,IFUN) = X
              ELSE
                  DPF00             = X
              ENDIF
          ELSE IF(COMAND .EQ. 'ERN') THEN
              IF(IFUN.GT.0) THEN
                  DNFPAR(IPAR,IFUN) = X
              ELSE
                  DNF00             = X
              ENDIF
          ELSE IF(COMAND .EQ. 'LOLIM') THEN
              IF(IFUN.GT.0) THEN
                  FPARLO(IPAR,IFUN) = X
              ELSE
                  F00LO             = X
              ENDIF
              CALL M_MINU(IPAR,IFUN)
          ELSE IF(COMAND .EQ. 'HILIM') THEN
              IF(IFUN.GT.0) THEN
                  FPARHI(IPAR,IFUN) = X
              ELSE
                  F00HI             = X
              ENDIF
              CALL M_MINU(IPAR,IFUN)
C
          ELSE IF(COMAND .EQ. 'X') THEN
              CALL UMNX(IBIN,IVAR,ISET,IDPTRD(ISET)
     +         ,NDIMD,NWPPTD,NBPPTD,X,NERR)
          ELSE IF(COMAND .EQ. 'DX') THEN
              CALL UMNDX(IBIN,1,ISET,IDPTRD(ISET),NDIMD,NWPPTD,NBPPTD
     +         ,X,NERR)
          ELSE IF(COMAND .EQ. 'DNX') THEN
              CALL UMNDXN(IBIN,1,ISET,IDPTRD(ISET),NDIMD,NWPPTD,NBPPTD
     +         ,X,NERR)
          ELSE IF(COMAND .EQ. 'DPX') THEN
              CALL UMNDXP(IBIN,1,ISET,IDPTRD(ISET),NDIMD,NWPPTD,NBPPTD
     +         ,X,NERR)
          ELSE IF(COMAND .EQ. 'Y') THEN
              CALL UMNE(IBIN,ISET,IDPTRD(ISET),NDIMD,NWPPTD,NBPPTD
     +         ,X,NERR)
          ELSE IF(COMAND .EQ. 'DY') THEN
              CALL UMNDE(IBIN,ISET,IDPTRD(ISET),NDIMD,NWPPTD,NBPPTD
     +         ,X,NERR)
          ELSE IF(COMAND .EQ. 'DNY') THEN
              CALL UMNDEL(IBIN,ISET,IDPTRD(ISET),NDIMD,NWPPTD,NBPPTD
     +         ,X,NERR)
          ELSE IF(COMAND .EQ. 'DPY') THEN
              CALL UMNDEH(IBIN,ISET,IDPTRD(ISET),NDIMD,NWPPTD,NBPPTD
     +         ,X,NERR)
C
C         A variable
C
          ELSE IF(ICMD.GT.0) THEN
              REGIS(IREG) = X
          ENDIF

          Lenc = LNBLNK(CTEMP)
          IF(QECHO) WRITE(LUNTTO,5000) CTEMP(:Lenc),X
5000      FORMAT(1X,A,' = ',1PG13.6)
      ENDIF

      CALL ZERTYQ('.FALSE.')
      GOTO 9100
C
C     Come here if error
C
9000  CONTINUE
      CALL ZERTYQ('.TRUE.')
C
9100  CONTINUE
      xbinnm = xbinsv
      ybinnm = ybinsv
      CALL ICMSYM(TSPSYM)
      TSDSCN = TSVSCN
      LENT   = LNBLNK(TSDSCN)
      CALL SDLSCN(TSDSCN(1:LENT))
999   END
