      subroutine m_tbpos(nax,jtb,itb,nsmode,nleg,athe,aphii
     + ,scligt,qins,qout,noptl,xlo,xhi,ylo,yhi,zlo,zhi
     + ,xl,yl,zl,xt,yt,xu,yu,xv,yv,ads,ada,adi,ado,qlflip,ang)
*
*----------------------------------------------------------------------
*     Sets up the many positions for the axes
*----------------------------------------------------------------------
*
      implicit none
*
      integer nax,jtb,itb,nsmode,nleg,noptl
      real athe,aphii,scligt,xlo,xhi,ylo,yhi,zlo,zhi
      logical qins,qout
      real xl,yl,zl,xt,yt,xu,yu,xv,yv,ads,ada,adi,ado,ang
      logical qlflip
*
      real aphi
*
      aphi = amod(aphii,360.0)
      if(aphi.lt.0.0) aphi = aphi + 360.0
      qlflip = .false.
      ang = 0.0
C
C     SET UP POSITION LIMITS
C
      if(nax.eq.1) then
        if(nsmode.eq.2) then
          if(noptl.eq.-1) then
            xl = xlo
          elseif(noptl.eq.+1) then
            xl = xhi
          else
            xl = 10.0**(0.5*(alog10(xlo) + alog10(xhi)))
          endif
        else
          if(noptl.eq.-1) then
            xl = xlo
          elseif(noptl.eq.+1) then
            xl = xhi
          else
            xl = 0.5*(xlo + xhi)
          endif
        endif
*
*       Positions depend on which real axis it is
*
        if(itb.eq.1) then
          yl  = ylo
          yt  = ylo
          yu  = yhi
        else
          yl  = yhi
          yt  = yhi
          yu  = ylo
        endif
*
*       Scale factors depend on just 1st or 2nd
*
        if(jtb.eq.1) then
          ads = +1.0
          ada = +1.0
          if((nleg.eq.1 .or. nleg.eq.2 .or. nleg.eq.8) .and.
     +     abs(athe).ne.90.0) then
            if(aphi.le.90.0) then
              ang = 0.0
            elseif(aphi.le.180.0) then
              qlflip = .true.
              ang = 180.0
              if(noptl.eq.-1) then
                xl = xhi
              elseif(noptl.eq.+1) then
                xl = xlo
              endif
            elseif(aphi.le.270.0) then
              ang = 180.0
              if(noptl.eq.-1) then
                xl = xhi
              elseif(noptl.eq.+1) then
                xl = xlo
              endif
            else
              qlflip = .true.
              ang = 0.0
            endif
          endif
        else
          ads = -1.0
          ada = -1.0
          if((nleg.eq.1 .or. nleg.eq.2 .or. nleg.eq.8) .and.
     +     abs(athe).ne.90.0) then
            if(aphi.le.90.0) then
              ang = 0.0
            elseif(aphi.le.180.0) then
              qlflip = .true.
              ang = 180.0
            elseif(aphi.le.270.0) then
              ang = 180.0
            else
              qlflip = .true.
              ang = 0.0
            endif
          endif
        endif
      else if(nax.eq.2) then
        if(nsmode.eq.2) then
          if(noptl.eq.-1) then
            yl = ylo
          elseif(noptl.eq.+1) then
            yl = yhi
          else
            yl = 10.0**(0.5*(alog10(ylo) + alog10(yhi)))
          endif
        else
          if(noptl.eq.-1) then
            yl = ylo
          elseif(noptl.eq.+1) then
            yl = yhi
          else
            yl = 0.5*(ylo + yhi)
          endif
        endif
        if(itb.eq.1) then
          xl  = xlo
          xt  = xlo
          xu  = xhi
        else
          xl  = xhi
          xt  = xhi
          xu  = xlo
        endif
*
*       Scale factors depend on just 1st or 2nd
*
        if(jtb.eq.1) then
          ads = +1.0
          ada = +1.0
          if((nleg.eq.1 .or. nleg.eq.2 .or. nleg.eq.8) .and.
     +     abs(athe).ne.90.0) then
            if(aphi.le.90.0) then
              ang = 90.0
              if(noptl.eq.-1) then
                yl = yhi
              elseif(noptl.eq.+1) then
                yl = ylo
              endif
            elseif(aphi.le.180.0) then
              qlflip = .true.
              ang = 90.0
              if(noptl.eq.-1) then
                yl = yhi
              elseif(noptl.eq.+1) then
                yl = ylo
              endif
            elseif(aphi.le.270.0) then
              ang = 270.0
            else
              qlflip = .true.
              ang = 270.0
            endif
*
*           Flip the y-axis label positions - may be angle dependent
*
          else
            ada = +1.0
          endif
        else
          ads = -1.0
          ada = -1.0
          if((nleg.eq.1 .or. nleg.eq.2 .or. nleg.eq.8) .and.
     +     abs(athe).ne.90.0) then
            if(aphi.le.90.0) then
              ang = 90.0
            elseif(aphi.le.180.0) then
              qlflip = .true.
              ang = 90.0
            elseif(aphi.le.270.0) then
              ang = 270.0
            else
              qlflip = .true.
              ang = 270.0
            endif
          endif
        endif
      else
        if(nsmode.eq.2) then
          if(noptl.eq.-1) then
            zl = zlo
          elseif(noptl.eq.+1) then
            zl = zhi
          else
            zl = 10.0**(0.5*(alog10(zlo) + alog10(zhi)))
          endif
        else
          if(noptl.eq.-1) then
            zl = zlo
          elseif(noptl.eq.+1) then
            zl = zhi
          else
            zl = 0.5*(zlo + zhi)
          endif
        endif
        if((nleg.eq.1 .or. nleg.eq.2 .or. nleg.eq.8) .and.
     +   abs(athe).ne.90.0) then
          if(aphi.le.90.0) then
            xt  = xlo
            yt  = yhi
            xu  = xhi
            yu  = yhi
            xv  = xhi
            yv  = ylo
            if(jtb.eq.1) then
              xl  = xlo
              yl  = yhi
            else
              xl  = xhi
              yl  = ylo
            endif
          elseif(aphi.le.180.0) then
            xt  = xhi
            yt  = yhi
            xu  = xhi
            yu  = ylo
            xv  = xlo
            yv  = ylo
            if(jtb.eq.1) then
              xl  = xhi
              yl  = yhi
            else
              xl  = xlo
              yl  = ylo
            endif
          elseif(aphi.le.270.0) then
            xt  = xhi
            yt  = ylo
            xu  = xlo
            yu  = ylo
            xv  = xlo
            yv  = yhi
            if(jtb.eq.1) then
              xl  = xhi
              yl  = ylo
            else
              xl  = xlo
              yl  = yhi
            endif
          else
            xt  = xlo
            yt  = ylo
            xu  = xlo
            yu  = yhi
            xv  = xhi
            yv  = yhi
            if(jtb.eq.1) then
              xl  = xlo
              yl  = ylo
            else
              xl  = xhi
              yl  = yhi
            endif
          endif
          if(jtb.eq.1) then
            ads = 1.0
            ada = 1.0
          else
            ads = -1.0
            ada = -1.0
          endif
        else
          xt  = xlo
          yt  = yhi
          xu  = xhi
          yu  = yhi
          xv  = xhi
          yv  = ylo
          if(itb.eq.1) then
            xl  = xlo
            yl  = yhi
          else
            xl  = xhi
            yl  = ylo
          endif
          if(jtb.eq.1) then
            ads = 1.0
            ada = 1.0
          else
            ads = -1.0
            ada = -1.0
          endif
        endif
      endif
C
C     IGTABL lego and surface plots are mapped onto -1,1
C
      if(nleg.eq.8) then
        ads = ads * scligt
      endif
C
C     SET UP FACTORS FOR DRAWING TICKS
C
      if(qins) then
        if((nleg.eq.1 .or. nleg.eq.2 .or. nleg.eq.8) .and.
     +   abs(athe).ne.90.0) then
          if(aphi.gt.180.0 .and. aphi.le.270.0) then
            adi = -1.0
          else
            adi = +1.0
          endif
        elseif(itb.eq.1) then
          adi = +1.0
        else
          adi = -1.0
        endif
      else
        adi = 0.0
      endif
c
      if(qout) then
        if((nleg.eq.1 .or. nleg.eq.2 .or. nleg.eq.8) .and.
     +   abs(athe).ne.90.0) then
          if(aphi.gt.180.0 .and. aphi.le.270.0) then
            ado = +1.0
          else
            ado = -1.0
          endif
        elseif(itb.eq.1) then
          ado = -1.0
        else
          ado = 1.0
        endif
      else
        ado = 0.0
      endif
*
      end
