      SUBROUTINE M_SCOL(IDELIM,QPLOT,QZERO,NPS1,NPS2,QPRDRW,IERR)
C
C-----------------------------------------------------------------------
C
C     Sets up the colours for different parts of the picture.
C
C     Called by MN_SET.
C
C-----------------------------------------------------------------------
C
      implicit none
*
#include "mnpar.inc"
#include "mnhpj.inc"
#include "mncmd.inc"
#include "mngrn.inc"
#include "mnlun.inc"
C
      INTEGER IDELIM,NPS1,NPS2,IERR
      LOGICAL QPLOT,QZERO,QPRDRW
C
      CHARACTER*80 THELP
      character tcmd*10
      INTEGER INUM(20)
      REAL FRAC(3)
      LOGICAL QALL
      integer ii,jj,ioerr,nwhat,nval,ncol,nloop,np,nchr
      real rval
*
      integer  inttyq,icmtyq,ivltyq,isttyq
      real     valtyq
      external inttyq,icmtyq,ivltyq,isttyq,valtyq
C
      IERR = 0
C
      IF(COMND1.EQ.'SHOW') THEN
        CALL MN_MES(LUNTTO,'I'
     +   ,' Colours of various parts of a picture')
        CALL MN_MES(LUNTTO,'I'
     +   ,' Use the SET COLOUR [variable] command to change things')
        WRITE(TXTMES,'('' Use of colour is'',L4)') QCOLOUR
        CALL MN_MES(LUNTTO,'I',TXTMES)
        DO 500 II=1,mcol_bgd
          IF(QPLOT) THEN
            WRITE(TXTMES,10500,IOSTAT=IOERR)
     1       TCOLN(II),COLNAM(ICOLP(II,NPS1))
          ELSE
            WRITE(TXTMES,10500,IOSTAT=IOERR)
     1       TCOLN(II),COLNAM(ICOLS(II))
          ENDIF
          CALL MN_MES(LUNTTO,'I',TXTMES)
  500   CONTINUE
10500   FORMAT(1X,'Colour of the ',A,T40,A)
        call mn_mes(LUNTTO,'I',' ')
        call mn_mes(LUNTTO,'I'
     +   ,' The following colours have been defined:')
        call mn_mes(LUNTTO,'I'
     +   ,' Ind  Colour       Red Green  Blue')
        do 600 ii=0,ncoldef
          if(colnam(ii).ne.' ') then
            write(TXTMES,'(I4,1X,A,3F6.2)') ii,colnam(ii)
     +       ,(colfrc(jj,ii),jj=1,3)
            call mn_mes(luntto,'I',txtmes)
          endif
  600   continue
        CALL MN_MES(LUNTTO,'E',' ')
        GOTO 9000
      ENDIF
C
      THELP = 'SET COLOUR'
      QALL  = .TRUE.
      NWHAT = 0
      CALL WAITYQ('Give variable and colour, ' //
     1 'or colour, or ?: ')
 1000 CONTINUE
      NVAL = INTTYQ(.TRUE.,IDELIM)
      IF(NVAL.EQ.0 .AND. IDELIM.EQ.ICHAR('?')) THEN
          CALL QUOTYQ(THELP)
          IDELIM = 0
          CALL MN_HLP(IDELIM,IERR)
          GOTO 1000
      ENDIF
      IF(IDELIM.GT.0) THEN
          IF(QALL) THEN
              CALL RESTYQ
              NWHAT = ICMTYQ(.TRUE.,IDELIM,TCOLN)
          ENDIF
C
C         Turn colour on
C
          IF(NWHAT.EQ.mcol_on) THEN
            CALL TVCOLR(.TRUE.)
C
C         Turn colour off
C
          ELSEIF(NWHAT.EQ.mcol_off) THEN
            CALL TVCOLR(.FALSE.)
C
C         Set colours back to default
C
          ELSEIF(NWHAT.EQ.mcol_def) THEN
            qcolour = .false.
            call m_scnam
            CALL TVCOLR(.TRUE.)
C
C         Change the colour representation for the current device.
C
          ELSEIF(NWHAT.EQ.mcol_rep) THEN
              CALL WAITYQ('Give colour index:' )
              NCOL = IVLTYQ(.TRUE.,IDELIM)
              CALL MN_NCK(NCOL,IDELIM,IERR)
              IF(IERR.NE.0) GOTO 9000
              if(ncol.gt.mcol) then
                write(txterr,'(''Colour index must be between 0 and''
     +           ,I3)') mcol
                CALL MN_ERR('M_SCOL',txterr)
                IERR = 1
                GOTO 9000
              endif
              NLOOP = 0
 1200         CONTINUE
              NLOOP = NLOOP + 1
              IF(NLOOP.EQ.1) THEN
                  CALL WAITYQ('Give red, green, blue fraction (0->1): ')
              ELSEIF(NLOOP.EQ.2) THEN
                  CALL WAITYQ('Give green, blue fraction (0->1): ')
              ELSEIF(NLOOP.EQ.3) THEN
                  CALL WAITYQ('Give blue fraction (0->1): ')
              ENDIF
              FRAC(NLOOP) = VALTYQ(.TRUE.,IDELIM)
              CALL MN_RCK(RVAL,IDELIM,IERR)
              IF(IERR.NE.0) GOTO 9000
              IF(FRAC(NLOOP).LT.0.0 .OR. FRAC(NLOOP).GT.1.0) THEN
                  CALL MN_ERR('M_SCOL'
     +             ,'Colour fraction must be between 0 and 1')
                  IERR = 1
                  GOTO 9000
              ENDIF
              IF(NLOOP.LT.3) GOTO 1200
C
              if(colnam(ncol).eq.' ' .or. idelim.eq.0) then
                call waityq('Give name for colour: ')
                nchr = isttyq(.true.,idelim,tcmd)
                if(nchr.gt.0) colnam(ncol) = tcmd
                if(colnam(ncol).eq.' ') then
                  call mn_err('M_SCOL'
     +             ,'You must give a name for the colour')
                  ierr = 1
                  goto 9000
                endif
              endif
              ncoldef = max0(ncol,ncoldef)
              colfrc(1,ncol) = frac(1)
              colfrc(2,ncol) = frac(2)
              colfrc(3,ncol) = frac(3)
C
              IF(LPDEV.GT.1) THEN
                  CALL ISCR(IPDEV(LPDEV),NCOL,FRAC(1),FRAC(2),FRAC(3))
              ELSE
                  CALL M_EMSG('M_SCOL'
     +             ,'You have no or a null output device selected')
              ENDIF
              GOTO 9000
          ELSEIF(NWHAT.GT.0 .AND. QALL) THEN
              QALL = .FALSE.
              CALL WAITYQ('Give colour: ')
              GOTO 1000
C
C         See if the colour name was given ,otherwise get the number
C
          ELSE
              CALL RESTYQ
              NVAL = ICMTYQ(.TRUE.,IDELIM,COLNAM)
              IF(NVAL.LE.0 .OR. IDELIM.GT.0) THEN
                  CALL RESTYQ
                  NVAL = IVLTYQ(.TRUE.,IDELIM)
                  NCOL = NVAL
              ELSE
                  NCOL = NVAL - 1
              ENDIF
          ENDIF
      ELSE
          NCOL = NVAL
      ENDIF
      CALL MN_NCK(NVAL,IDELIM,IERR)
      IF(IERR.GT.0) GOTO 9000
C
      IF(QALL) CALL VFILL(INUM,MCOL_ALL,NCOL)
      IF(NVAL.EQ.0) THEN
          IF(QALL) THEN
              CALL UCOPY_i(ICOLD,INUM,MCOL_ALL)
          ELSE
              NCOL = ICOLD(NWHAT)
          ENDIF
      ENDIF
      IF(QPLOT) THEN
          DO 2000 NP=NPS1,NPS2
              QPRDRW = .TRUE.
              IF(QALL) THEN
                  CALL UCOPY_i(INUM,ICOLP(1,NP),MCOL_ALL)
              ELSE
                  ICOLP(NWHAT,NP) = NCOL
                  if(nwhat.eq.mcol_sym) then
                     icolp(nwhat+1,np) = ncol
                     icolp(nwhat+2,np) = ncol
                  endif
              ENDIF
2000      CONTINUE
      ENDIF
C
      IF(.NOT.QPLOT .OR. QZERO) THEN
          IF(QALL) THEN
              CALL UCOPY_i(INUM,ICOLS,mcol_all)
          ELSE
              ICOLS(NWHAT) = NCOL
              if(nwhat.eq.mcol_sym) then
                icols(nwhat+1) = ncol
                icols(nwhat+2) = ncol
              endif
          ENDIF
      ENDIF
C
9000  CONTINUE
      END
