      INTEGER FUNCTION IMNCH(NP,NH,NC,NE,tval,NERR)
C
C     Gives the length and value of a charcter variable in a CWN.
C     If necessary reads in the HBOOK Ntuple
C     np Point
C     nh Histogram
C     nc Variable
C     ne Element
C
      implicit none
*
#include "mnpar.inc"
#include "mndat.inc"
#include "mninf.inc"
#include "mnlst.inc"
#include "mntpl.inc"
#include "mncwn.inc"
*
      integer np,nh,nc,ne,nerr
      character*(*) tval
C
      INTEGER ida,idb,ierr,n1,n2,n3,nhf
      real adat(1)
      integer lnblnk
C
      IMNCH = 0
      TVAL  = ' '
C
      IF(NH.LE.0) THEN
        NERR = 1
        CALL AMNERR('IMNCH',NERR,N1,N2,N3)
        RETURN
      ENDIF
C     
      IF(NH.NE.NHALST) THEN
        IDAL = IDIDA(NH)
        IDBL = IDIDB(NH)
        CALL MN_HGT(IDAL,IDBL,NHF)
        NPTRHL = NPTRH
        NPTRDL = NPTRD
        NDIML  = NDIM
        NWPPTL = NWPPT
        NBPPTL = NBPPT
        NPNTL  = NPNT
        NWDATL = NWDAT
        EDENTL = EDENT
        EDLOL  = EDLO
        EDHIL  = EDHI
        CALL UCOPY_i(IDBIN,IDBINL,IABS(NDIM))
        CALL UCOPY_r(ADLO,ADLOL,IABS(NDIM))
        CALL UCOPY_r(ADHI,ADHIL,IABS(NDIM))
        if(nwdat.le.0) then
          nvcwn = 0
          ida = idal
          idb = idbl
          call m_ntppnt(ida,idb,0,ierr,adat)
          if(ierr.ne.0) then
            NERR = 5
            CALL AMNERR('IMNCH',NERR,N1,N2,N3)
            RETURN
          endif
        else
          qcwntpl = .false.
          nerr = 11
          CALL AMNERR('IMNCH',NERR,idal,idbl,N3)
          return
        endif
      ENDIF
C     
      IF(Np.LT.0 .OR. Np.GT.NPNTL) THEN
        NERR = 3
        CALL AMNERR('IMNCH',NERR,NP,NPNTL,N3)
        RETURN
      ENDIF
C
      IF(Nc.le.0 .or. nc.gt.iabs(ndim)) then
        NERR = 6
        CALL AMNERR('IMNCH',NERR,NC,NPNTL,N3)
        RETURN
      ENDIF
C
      IF(Ne.le.0 .or. ne.gt.ivelem(nc)) then
        NERR = 7
        CALL AMNERR('IMNCH',NERR,Ne,ivelem(nc),N3)
        RETURN
      ENDIF
C     
      call m_ntppnt(idal,idbl,np,nerr,adat)
      if(nerr.eq.0) then
        call m_ntpchv(nc,ne,tval,nerr)
        if(nerr.eq.0) then
          imnch = lnblnk(tval)
        endif
      endif
C       
      NHALST = NH
 9000 continue
C       
      RETURN
      END
