C
      SUBROUTINE M_FCMS(NMODE,TFILE,TFILO,TNAMO,NADR,IERR)
C
C     COMPILES THE COMIS FUNCTION, GETS THE FILE NAME AND FUNCTION NAME
C     AND THE ADDRESS OF THE FUNCTION.
C     NMODE = -1 allows either FUNCTION or SUBROUTINE
C     NMODE =  0 looks for a FUNCTION
C     NMODE =  1 looks for a SUBROUTINE
C
#include "mnlun.inc"
C
      CHARACTER*(*) TFILE,TFILO,TNAMO
      INTEGER NMODE,NADR,IERR
C
      CHARACTER*255 TXT1,TXT2,TCMD
      INTEGER CSADDR,LENF
C
      IERR = 0
C
      LENF = LENOCC(TFILE)
#if ( defined(VMS) )
      IND = INDEX(TFILE(1:LENF),';')
      IF(IND.GT.0) LENF = IND - 1
#endif

      TCMD = '!FILE ' // TFILE(1:LENF)
      NTCMD = LENOCC(TCMD)
      CALL CSEXEC(TCMD(1:NTCMD),IERR)
      IF(IERR.NE.0) THEN
          CALL MN_ERR('M_FCMS'
     +     ,'Error executing CSEXEC command in COMIS')
          IERR = 2
          GOTO 9000
      ENDIF
C
      TXT1 = TFILE
      CALL MN_FIL(42,LUNTMP,TXT1,IDELIM,JERR)
      IF(JERR.NE.0) THEN
          IERR = 2
          CALL MN_ERR('M_FCMS','COMIS function will not be added')
          GOTO 9000
      ENDIF
C
C     Strip version number off the VMS filename
C
#if ( defined(VMS) )
      LENT = INDEX(TXT1,';') - 1
      IF(LENT.LE.0) LENT = LENOCC(TXT1)
#endif
#if ( !defined(VMS) )
      LENT = LENOCC(TXT1)
#endif

      TFILO = TXT1(1:LENT)
C
5360  CONTINUE
      TXT1 = ' '
      READ(LUNTMP,'(A)',ERR=5380,END=5380) TXT1
      IF(TXT1.EQ.' ') GOTO 5360
      IF(TXT1(1:1).EQ.'C' .OR. TXT1(1:1).EQ.'*') GOTO 5360
      CALL M_LUPC(TXT1,TXT2)
      TXT1 = TXT2
      IND1 = 999
      IND2 = 999
      IF(NMODE.EQ.0 .OR. NMODE.EQ.-1) THEN
          IND1 = INDEX(TXT1,'FUNCTION')
          IF(IND1.EQ.0) IND1 = 999
          NN1  = 8
      ENDIF
      IF(NMODE.EQ.1 .OR. NMODE.EQ.-1) THEN
          IND2 = INDEX(TXT1,'SUBROUTINE')
          IF(IND2.EQ.0) IND2 = 999
          NN2  = 10
      ENDIF
      IND = MIN0(IND1,IND2)
      IF(IND.EQ.IND1) THEN
          NN = NN1
      ELSE
          NN = NN2
      ENDIF
      IF(IND.LE.0 .OR. IND.EQ.999) GOTO 5360
      IND3 = INDEX(TXT1(IND:),'(')
      IF(IND3.LT.NN+2) GOTO 5360
      TXT2 = TXT1(IND+NN:IND+IND3-2)
      CALL M_LTRM(TXT2,TXT1)
      TNAMO = TXT1
      GOTO 5390
C
5380  CONTINUE
      CLOSE(UNIT=LUNTMP)
      IF(NMODE.EQ.-1) THEN
          CALL M_EMSG('M_FCMS'
     +     ,'Error trying to find COMIS function or subroutine name')
          CALL M_EMSG('M_FCMS'
     +     ,'There must be a FUNCTION or a' //
     +      ' SUBROUTINE name(...) card in your file')
      ELSEIF(NMODE.EQ.0) THEN
          CALL M_EMSG('M_FCMS'
     +     ,'Error trying to find COMIS function name')
          CALL M_EMSG('M_FCMS'
     +     ,'There must be a FUNCTION name(...) card in your file')
      ELSE
          CALL M_EMSG('M_FCMS'
     +     ,'Error trying to find COMIS subroutine name')
          CALL M_EMSG('M_FCMS'
     +     ,'There must be a SUBROUTINE name(...) card in your file')
      ENDIF
      CALL MN_ERR('M_FCMS'
     1  ,'COMIS function will not be added')
      IERR = 3
      GOTO 9000
5390  CONTINUE
      CLOSE(UNIT=LUNTMP)
C
C     GET THE ADDRESS OF THE FUNCTION
C
      LENT = LENOCC(TNAMO)
      NADR = CSADDR(TNAMO(1:LENT))
C
      WRITE(TXTMES
     + ,'('' Compiled COMIS function: '',A,''  Address'',I8)')
     + TNAMO(1:LENT),NADR
      CALL MN_MES(LUNTTO,'M',TXTMES)
      LENT = LENOCC(TFILO)
      TXTMES = ' File: ' // TFILO(1:LENT)
      CALL MN_MES(LUNTTO,'ME',TXTMES)
      IF(NADR.LE.0) THEN
          TXTERR = 'Error getting address of function: ' //
     +     TNAMO(1:LENT)
          CALL M_EMSG('M_FCMS',TXTERR)
          CALL MN_ERR('M_FCMS','COMIS function will not be added')
          IERR = 4
      ENDIF
C
9000  CONTINUE
      END
