      SUBROUTINE M_PTIM (idate,itime,ISECS)
*
************************************************************************
*                                                                      *
*        SUBR. M_PTIM (idate, itime, isecs)                            *
*                                                                      *
*   Converts from a number of minutes passed since midnight Jan 1,1980 *
*   to a date and time                                                 *
*                                                                      *
*   Arguments :                                                        *
*                                                                      *
*     IDATE*   Date                                                    *
*     ITIME*   Time                                                    *
*     ISECS    Number of minutes passed since 00.00 on Jan 1, 1980     *
*                                                                      *
************************************************************************
*
      implicit none
*
#include "mntim.inc"
*
      integer idate,itime,isecs
*
      integer i,iii,imin,ihou,iday,imon,iyea,ityp
     + ,nday,nmin
*
#include "mntimd.inc"
*
      if(isecs.le.0) then
          idate = 800101
          itime = 000000
          return
      endif
*
      nday = isecs / (24*60)
      nmin = mod(isecs,24*60)
*
      iii = nday
      do i=1,mdayy
          if(idayy(i).ge.iii) then
              iyea = i - 1
              goto 1000
          endif
      enddo
 1000 continue
      ityp = mod(iyea,4)
      if(ityp.eq.0) then
          ityp = 2
      else
          ityp = 1
      endif
*
      if(iyea.gt.0) then
          iii = nday - idayy(iyea)
      else
          iii = nday
      endif
      do i=2,12
          if(idaym(i,ityp).gt.iii) then
              imon = i - 1
              goto 2000
          endif
      enddo
      imon = 12
 2000 continue
      iday = iii - idaym(imon,ityp) + 1
*
      iii  = nmin
      ihou = iii / (60)
      iii  = mod(iii,60)
      imin = iii
*
      if(iyea.lt.20) then
        idate = (iyea+80)*10000 + imon*100 + iday
      else
        idate = (iyea+00)*10000 + imon*100 + iday
      endif
      itime = ihou*100 + imin
*                                                             END M_PTIM
      END
