      SUBROUTINE MN_MES(LUN,TFLAG,TEXT)
C
C     Subroutine to handle all writing of text in Mn_Fit
C     If we are in CPC environment
C     TFLAG = 'M' means a new message to the message window
C     TFLAG = 'I' means the stuff will go to the index window
C     TFLAG = ' ' means add another line
C     TFLAG = 'E' means end of message and print the line
C
C     If not in CPC then a normal write is performed
C
C     TK/TCL interface is controlled by the QTKTCL logical
C     If it is on, then write the string tktcl-end for flag 'E'
C
      IMPLICIT NONE
C
#if ( defined(L3_CPC) )
#include "mncpc.inc"
      CHARACTER*80 TBUF(MCPC_MES)
      integer lenm,nline
      CHARACTER*1   TFLG
#endif

C
#include "mnflg.inc"
#include "mnlun.inc"
C
      INTEGER LUN
      CHARACTER*(*) TFLAG,TEXT
C
      INTEGER LENFLG,LENT,LNBLNK
C
#if ( defined(L3_CPC) )
      DATA TFLG/' '/
      DATA NLINE/0/
#endif

C
      lenflg = len(tflag)
      LENT   = max0(1,LNBLNK(TEXT))
#if ( !defined(L3_CPC) )
      IF(TFLAG(1:1).NE.'E' .OR. TEXT.NE.' ') THEN
        WRITE(LUN,'(A)') TEXT(:LENT)
      endif
      IF(LUN.EQ.LUNTTO .AND. QTKTCL .AND.
     +   (TFLAG(1:1).EQ.'E' .or.
     +   (lenflg.gt.1 .and. tflag(2:2).eq.'E'))) THEN
        WRITE(LUN,'('' :tktcl-end:'')')
      ENDIF
C
#endif
#if ( defined(L3_CPC) )
      IF(LUN.NE.LUNTTO) THEN
          IF(TFLAG(1:1).NE.'E' .OR. TEXT.NE.' ')
     +     WRITE(LUN,'(A)') TEXT(:lent)
      ELSE
C
C         Message or Index
C
          lenm = max0(1,min0(80-9-7-lenflg-7,lnblnk(text)))
          WRITE(LUN,'('' MN_MES: '','' Flag: '',A,'' Text: '',A)')
     +     TFLAG,TEXT(:lenm)
          IF(TFLAG(1:1).EQ.'M' .OR. TFLAG(1:1).EQ.'I') THEN
              IF(NLINE.EQ.0)  THEN
                  TFLG = TFLAG
              ENDIF
              NLINE = NLINE + 1
              TBUF(NLINE) = TEXT(:lent)
              IF(LENFLG.GT.1 .AND. TFLAG(2:2).EQ.'E') THEN
                  IF(NLINE.LT.MCPC_MES) TBUF(NLINE+1) = ' '
                  CALL SEND_MES(TFLG,TBUF)
                  NLINE = 0
              ENDIF
              IF(NLINE.GE.MCPC_MES) THEN
                  CALL SEND_MES(TFLG,TBUF)
                  NLINE = 0
              ENDIF
C
C         Continuation of current message or index
C
          ELSEIF(TFLAG(1:1).EQ.' ') THEN
              NLINE = NLINE + 1
              TBUF(NLINE) = TEXT(:lent)
              IF(NLINE.GE.MCPC_MES) THEN
                  CALL SEND_MES(TFLG,TBUF)
                  NLINE = 0
              ENDIF
C
C         End of message or index
C
          ELSEIF(TFLAG(1:1).EQ.'E') THEN
              IF(TEXT.NE.' ') THEN
                  NLINE = NLINE + 1
                  TBUF(NLINE) = TEXT(:lent)
              ENDIF
              IF(NLINE.LT.MCPC_MES) TBUF(NLINE+1) = ' '
              CALL SEND_MES(TFLG,TBUF)
              NLINE = 0
C
C         Prompt
C
c          ELSEIF(TFLAG(1:1).EQ.'P') THEN
c              TFLG = TFLAG(1:1)
c              NLINE = 1
c              TBUF(NLINE) = TEXT(:lent)
c              CALL SEND_MES(TFLG,TBUF)
          ENDIF
      ENDIF
C
#endif

C
      END
