      SUBROUTINE cleo_MESOUT( CRBEF, CRAFT )
C.......................................................................
C.
C. MESOUT - Write the contents of the message buffer CHMESS
C.
C. Inputs    : CRBEF  - Preceed write with this many CR/LF's
C.           : CRAFT  - Follow  write with this many CR/LF's
C. Outputs   : None
C. COMMON    : MESBUF MESLUN
C. Calls     : MESINI
C. Called    : <USER>
C.
C.......................................................................
C
C------------------------- Argument declarations -----------------------
C
      INTEGER CRBEF, CRAFT
C
C------------------------- EXTERNAL declarations -----------------------
C
      INTEGER  LENOCC
      EXTERNAL LENOCC
C
C------------------------- SEQUENCE declarations -----------------------
C
*
* MSSUCC - Message severity is SUCCESS
* MSINFO - Message severity is INFORMATION
* MSWARN - Message severity is WARNING
* MSERRO - Message severity is ERROR
* MSFATA - Message severity is FATAL
* CHMESS - Text of current message
*
      CHARACTER*(*) MSSUCC,             MSINFO
      PARAMETER(    MSSUCC = 'SUCCESS', MSINFO = 'INFORMATION' )
      CHARACTER*(*) MSWARN,             MSERRO
      PARAMETER(    MSWARN = 'WARNING', MSERRO = 'ERROR'       )
      CHARACTER*(*) MSFATA
      PARAMETER(    MSFATA = 'FATAL'                           )
*
      CHARACTER*132   CHMESS
      COMMON /MESREP/ CHMESS
*
*
* MESLIN - LUN for standard input
* MESLOU - LUN for standard output
* MESLER - LUN for standard error
*
      INTEGER         MESLIN, MESLOU, MESLER
      COMMON /MESLUN/ MESLIN, MESLOU, MESLER
*
C
C------------------------- Local    declarations -----------------------
C
      INTEGER I
      LOGICAL LFIRST
C
C------------------------- SAVE     declarations -----------------------
C
      SAVE    LFIRST
C
C------------------------- DATA  initializations -----------------------
C
      DATA    LFIRST /.TRUE./
C
C---------------------- Executable code starts here --------------------
C
*
      IF( LFIRST ) THEN
         LFIRST = .FALSE.
         CALL CLEO_MESINI
      ENDIF
C
      DO 10 I = 1, CRBEF
         WRITE( MESLOU, 1000 )
10    CONTINUE
C
      WRITE( MESLOU, 2000 ) CHMESS(1:LENOCC(CHMESS))
C
      DO 20 I = 1, CRAFT
         WRITE( MESLOU, 1000 )
20    CONTINUE
C
      RETURN
*
1000  FORMAT(1X)
2000  FORMAT(A)
*
      END
